/** 
* Returns true if browser is IE.
*/ 
function isBrowserIE() { 

	var userAgent = navigator.userAgent.toLowerCase(); 
	if ( userAgent.indexOf( "msie" ) > -1 ) return true;
	return false;
}

function setVisible(elem, cond) {
	elem.style.display = cond ? "" : "none";	
} 

function switchOddEven (current) {
	return current=="odd" ? "even" : "odd";	
} 

function swapImages(targetImg, sourceImg) {
	targetImg.src=sourceImg.src;
} 


/* Util function. Creates button element with given caption. */
function createButton(text) {
	var button = document.createElement("input");
	button.type = "button";
	button.value = text;
        button.className = "docAttachmentButton";
	return button;	
}

/* Util function. Creates button element with given caption and click handler. */
function createButton1(text, onclickHandler) {
	var button = createButton(text);
	button.onclick = onclickHandler;
	button.className = "button";
	return button;	
}

function createAndAppendChildElement(elementType, parent, cssClass) {
	child = document.createElement(elementType);
	child.className += cssClass;
	parent.appendChild(child);
	return child;
}

function createAndAppendChildElementWithText(elementType, parent, cssClass, textContent) {
	child = createAndAppendChildElement(elementType, parent, cssClass);
	text = document.createTextNode(textContent);
	child.appendChild(text);
	return child;
}

function createAndAppendChildElementWithHtmlContent(elementType, parent, cssClass, htmlContent) {
	child = createAndAppendChildElement(elementType, parent, cssClass);
	child.innerHTML=htmlContent;
	return child;
}

/* Use this function since IE does not support getElementsByClassName. Assumption is that there
is only one item of this class in the parent (can't use document.getElementById since mulitple
instances of the same view can exist */
function getElementByClass(parent, className){
	if (isBrowserIE() ) {
	  var elements = parent.getElementsByTagName("*");
	  for(i=0;i<elements.length;i++){
		if(elements[i].getAttribute("class") == className){
		  return elements[i];
		}
	  }
	  
	} else {
		return parent.getElementsByClassName(className)[0];
	}
	return null;
}

/*
 * Ensures first child that is a non-textelement is returned
 */
function getFirstProperChild( element ) {
	fc=element.firstChild;
	while (fc.nodeType!=1) {
		fc=fc.nextSibling;
	}
	return fc;
}

/*
 * Formats a multivalue element to a semi-colon separated format. 
 * 		<item type="ECMMultiValue"> ----> mvItem
            <value type="ANY[]">
              <item type="Boolean"><![CDATA[true]]></item>
              <item type="Boolean"><![CDATA[false]]></item>
              <item type="Boolean"><![CDATA[true]]></item>
            </value>
          </item>
 */
function formatMultiValue(mvItem) {
	
	var mvContent = "", j=0;
	valueNode = mvItem.getElementsByTagName('value')[0];
	
	if (valueNode) {
		dataItems = valueNode.childNodes;
		
		for (j=0; j<dataItems.length; j++) {
			if (dataItems[j].nodeType != 1) continue; // Ignore text nodes which show up as children
			mvContent += dataItems[j].childNodes[0].data + "; ";
		}
		if (j>0) 
			mvContent = mvContent.substring(0, mvContent.length - 2); // Trim the "; "
	}
	
	return mvContent;
	
}


/**
 * Build the URL of the Servelet for retrieving document content
 */
function buildDocumentURLString (searchUrl, ecmServerConfigurationName, portalContextRoot) {
	var searchURL = dojo.queryToObject(searchUrl.substring(searchUrl.indexOf("?") + 1));
	return this.location.protocol + '//' + this.location.host  + portalContextRoot+'/jsp/ecmDocument?operation=ajax_getDocumentContent&snapshotId=' + searchURL.snapshotId + '&ecmServerConfigurationName=' + ecmServerConfigurationName +'&documentId=';
}

/**
 * Build the URL of the Servelet for retrieving URL content
 */
function buildURLString (portalContextRoot) {
	return this.location.protocol + '//' + this.location.host + portalContextRoot+'/jsp/ecmDocument?operation=ajax_getDocumentContent&url=';
}

function initializeFieldValue(propertiesFS, objectTypeId, values) {
	if (propertiesFS == undefined || objectTypeId == undefined || values == undefined) {
		return;
	}	
	for (i=0; i < values.length; i++) {
		var value = values[i].value;
		var type = values[i].type;					 		
		var newObjectTypeId = objectTypeId;
		
		if (i > 0) {
			newObjectTypeId = objectTypeId + "$" + i.toString();
		}
		var input = propertiesFS.getRow(newObjectTypeId);
		
		if (input == null) {
			// create a new one
			add = propertiesFS.getAddButton(objectTypeId);
			add.onclick();
			input = propertiesFS.getRow(newObjectTypeId);
		}
		
		if (input != null && value != null && type != null) {				
			if (type == 'Date') {			
				dt = dijit.byId(newObjectTypeId);
				if (dt) {
					if (typeof value == 'string') {
						var index = value.indexOf(" ");
						if (index > -1) {
							value = value.substring(0, index);
						} 	
					}							 
					dt.set('value', new Date(value));					
				}
				
			} else if (type == 'Boolean') {
				cb = dijit.byId(newObjectTypeId);
				if (cb) {
					if(value == 'true')
						cb.set('value', value);
				}
			} else if (type == 'hidden' || type == 'file') {
				input.value = value;
			} else {
				tb = dijit.byId(newObjectTypeId);
				if(tb) {
					tb.set('value', value);
				}
			}
		}	
	}
}

function convertValues(values) {
	cValues = [];

	var i = 0;
	
	for (i=0; i < values.length; i++) {
		if (values[i].childNodes.length > 0) {
			value = values[i].childNodes[0].data;
			type = values[i].getAttribute('type');
			
			if (type == 'ECMMultiValue') {
				var items = values[i].getElementsByTagName('item');
				convertValues(items);
			} else {
				if (value != null && type != null) {
					obj = new Object();
					obj.type = type;
					obj.value = value;
					cValues.push(obj);
				}
			}
		}
	}
	return cValues;
}

function createChildElementWithText(elementType, cssClass, textContent) {
	child = createChildElement(elementType, cssClass);
	text = document.createTextNode(textContent);
	child.appendChild(text);
	return child;
}


function createChildElement(elementType, cssClass) {
	child = document.createElement(elementType);
	if (cssClass)
		child.className += cssClass;
	return child;
}

function createHiddenInputElement(parent, name, value) {
	var input = createInputElement(name, 'hidden');
	input.value = value;
	parent.appendChild(input);	
}

function createInputElement(name, propertyType) {
	var inupt = null;
	
	if (propertyType == 'datetime') {
		input = createChildElement('div', undefined);		
	} else if(propertyType == 'boolean') {
		input = createChildElement('div', undefined);
		input.name = name;
	}	else {
		input = createChildElement('input', undefined);
		
		if (propertyType == 'hidden')
			input.type = "hidden";
		else if (propertyType == 'file')
			input.type = "file";
		else if (propertyType == 'text')
			input.type = "text";
		else {
			input = createChildElement('div', undefined);
		}
		input.name = name;
	}	
	return input;		
}

function isInteger(s) {
	if(s == null || s == "")
		return true;
	s = s.replace(/^0+/, '');
	return (parseInt(s,10).toString())===s;
}

function isDecimal(s) {
	if(s == null || s == "")
		return true;
	var zero = s - s;
	return (!isNaN(zero));
} 

function validateDate(date) {
	if (Object.prototype.toString.call(date) !== "[object Date]" )
		return "invalid";
	if (isNaN(date.getTime()))
		return "invalid";
	else
		return "valid";
}

function validateIntegers(row, field, value, onkeyup, valid) {
	var index = field.lastIndexOf("$");
	var parentField;
	if (index != -1) {
		parentField = field.substring(0, index);
	} else
		parentField = field;
						
	validInteger = isInteger(value);
	if(!validInteger) {
		if(!onkeyup) {
			setVisible(document.getElementById('invalidValueError'), true);
			(document.getElementById(parentField)).childNodes[0].style.color='#FF0000';
		}
		valid = false;
	} else {
		if(valid && !onkeyup)
			setVisible(document.getElementById('invalidValueError'), false);
		(document.getElementById(parentField)).childNodes[0].style.color='#000000';
	}
	return valid;
}

function validateDecimals(row, field, value, onkeyup, valid) {
	var index = field.lastIndexOf("$");
	var parentField;
	if (index != -1) {
		parentField = field.substring(0, index);
	} else
		parentField = field;
		
	validDecimal = isDecimal(value);
	if(!validDecimal) {
		if(!onkeyup) {
			setVisible(document.getElementById('invalidValueError'), true);
			(document.getElementById(parentField)).childNodes[0].style.color='#FF0000';
		}
		valid = false;
	} else {
		if(valid && !onkeyup)
			setVisible(document.getElementById('invalidValueError'), false);
		(document.getElementById(parentField)).childNodes[0].style.color='#000000';
	}
	return valid;
}

function validateChoices(row, field, a, obj, onkeyup, valid) {
	var index = field.lastIndexOf("$");
	var parentField;
	if (index != -1) {
		parentField = field.substring(0, index);
	} else
		parentField = field;
	
	validChoice = arrayContains(a, obj);
	if(!validChoice) {
		if(!onkeyup) {
			setVisible(document.getElementById('invalidValueError'), true);
			(document.getElementById(parentField)).childNodes[0].style.color='#FF0000';
		}
		valid = false;
	} else {
		if(valid && !onkeyup)
			setVisible(document.getElementById('invalidValueError'), false);
		(document.getElementById(parentField)).childNodes[0].style.color='#000000';
	}
	return valid;
}

function arrayContains(a, obj) {
	var i = a.length;
    while (i--) {
       if (a[i].name[0] === obj) {
           return true;
       }
    }
    return false;
}

function getChildren(parent, tagName) {
	var children = parent.childNodes,
	arr = [],
	currChild;
	for (var i = 0, len = children.length; i < len; i++) {
		currChild = children[i];
		if (currChild.nodeType == 1 && currChild.tagName.toLowerCase() == tagName) {
			arr.push(currChild);
		}
	}
	return arr;
}

function convertURLtoCurrentSnapshotId(oldVal, portalContextRoot) {
	var newVal = portalContextRoot+'/jsp/callService.do?serviceRef=<service-id>&snapshotId=<snapshot-id>';
	
	var paSnapshotId = null;
	for (var key in com_ibm_bpm_coach.projectsnapshot) {
		paSnapshotId = com_ibm_bpm_coach.projectsnapshot[key];
		break;
	}
	
	var serviceId = null;
	//var snapshotId = null;
	var index = null;
	index = oldVal.lastIndexOf("/service/");
	serviceId = oldVal.substring(index + 9, oldVal.length);
	index = serviceId.indexOf("?");
	serviceId = serviceId.substring(0, index);
	
	/*index = oldVal.lastIndexOf("?snapshotId=");
	snapshotId = oldVal.substring(index + 12, oldVal.length);
	index = snapshotId.indexOf("&");
	snapshotId = snapshotId.substring(0, index);*/
	newVal = newVal.replace("<service-id>", serviceId);
	newVal = newVal.replace("<snapshot-id>", paSnapshotId);
	return newVal;
}

function createFilteringSelectWidget(id, name, required, store, input) {
	new dijit.form.FilteringSelect({
		id: id,
		name: name,
		required: required,
		store: store,
		invalidMessage: documentListView_invalidValue,
		missingMessage: documentListView_valueRequired,
		hasDownArrow: true
	}, input);
}

function createSelectWidget(id, name, required, store, input) {
	var select = new dijit.form.Select({
		id: id,
		name: name,
		required: required,
		store: store,
		invalidMessage: documentListView_invalidValue,
		missingMessage: documentListView_valueRequired,
		hasDownArrow: true
	}, input);
	select.startup();
	return select;
}

function createDateTimeWidget(id, name, required, input) {
	dt = dijit.byId(id);
	if (dt)
		dt.destroy();
	new dijit.form.DateTextBox({
		id: id,
		name: name,
		required: required,
		invalidMessage: documentListView_invalidDateTime,
		missingMessage: documentListView_valueRequired
	}, input);
}

function createCheckBoxWidget(id, name, input) {
	cb = dijit.byId(id);
	if (cb)
		cb.destroy();
	new dijit.form.CheckBox({
		id: id,
		name: name,
		value: "true"
	}, input);
}

function createTextBoxWidget(id, name, required, input, propertyType) {
	tb = dijit.byId(id);
	if (tb)
		tb.destroy();
	new dijit.form.ComboBox({
		id: id,
		name: name,
		propertyType: propertyType,
		required: required,
		missingMessage: documentListView_valueRequired,
		documentPropertiesFieldSet: this.documentPropertiesFieldSet,
		regExpGen: function(constrains) {
			if(propertyType=="integer") {
				this.invalidMessage = documentListView_invalidInteger;
				return '-?\\d+';
			}
			else if(propertyType=="decimal") {
				this.invalidMessage = documentListView_invalidDecimal;
				return '-?\\d*\\.?\\d+';
			}
			
			else
				return '.*';
		},
		hasDownArrow: false
	}, input);

}

function indexOf(arr, obj){
	for(var i=0; i<arr.length; i++){
		if(arr[i]==obj){
			return i;
		}
	}
	return -1;
}

function htmlStringDecoder(str){
	var div = document.createElement('div');
	div.innerHTML = str;
	if(div.innerText){
		return div.innerText;
	} else {
		return div.textContent;
	}
}
