// Note: 'this' in this script is the document window (not view)
var amountOfSpacing = 0;
var numberOfObjects = 0;

var documentListView_button_addDoc = "Add Document";
var documentListView_button_cancel = "Cancel";
var documentListView_button_ok = "OK";
var documentListView_bpmDocTypeLabel_file = "File";
var documentListView_bpmDocTypeLabel_url = "URL";
var documentListView_documentContentHeader = "Document Content";
var documentListView_bpmDocumentType = "Type";
var documentListView_urlLinkHeader = "URL Link";
var documentListView_documentCreationFailure = "Document creation failed. Contact server administrator for details.";
var documentListView_documentCreationSuccess = "Document created successfully.";
var documentListView_documentPropertiesHeader = "Document Properties";
var documentListView_documentTypeHeader = "Document Type";
var documentListView_documentTypesError = "Error retrieving document types.";
var documentListView_getDocumentAJAXSrvcError = "Get Document AJAX service cannot be located.";
var documentListView_getTypeDescendantsAJAXSrvcError = "Get Type Descendants AJAX service cannot be located.";
var documentListView_getTypeDefinitionAJAXSrvcError = "Get Type Definition AJAX service cannot be located."
var documentListView_label_file = "File Name";
var documentListView_label_url = "URL";
var documentListView_requiredFieldsMissing = "Please enter a value for the highlighted fields.";
var documentListView_invalidValues = "Please enter a valid value for the highlighted fields.";
var documentListView_invalidInteger = "Enter a valid integer.";
var documentListView_invalidDecimal = "Enter a valid decimal.";
var documentListView_invalidDateTime = "Enter a valid DateTime.";
var documentListView_invalidValue = "Enter a valid value.";
var documentListView_viewDoc = "View Document";
var documentListView_updateDoc = "Update Document";
var documentListView_updateDoc_link = "Update Document";
var documentListView_uploadDoc = "Create Document";
var documentListView_uploadDoc_button = "Create Document";
var documentListView_noIdError = "Please add an ID (cmis:objectId) to your query as documents cannot be viewed or updated without it.";
var documentListView_noVersionIdError = "Please add version series ID (cmis:versionSeriesId) to your query as document revisions cannot be viewed without it.";
var documentListView_noNameNoContent = "You will be creating a document with no name and content. It will only be retrievable by the ID. Continue?";
var documentListView_noContentWithName = "There is no file content provided. Continue?";
var documentListView_noContentWithProperties = "The properties were updated but the file contains no content. Continue?";
var documentListView_button_refresh = "Refresh";
var documentListView_title = "Document List";
var documentListView_documentSearchError = "Error retrieving documents.";
var documentListView_documentSearchError_missingProperties = "An error occurred while processing the search result. A search query must include the following properties: ${0}.";
var documentListView_documentVersionsError = "Error retrieving document revisions.";
var documentListView_documentContentView = "Document Content View";
var documentListView_noDocumentsFound = "No documents were found.";
var documentListView_revisionTitle = "Revision";
var documentListView_fileNameTitle = "Name";
var documentListView_revisionDateTitle = "Revision Date";
var documentListView_lastModifiedByTitle = "Last Modified By";
var documentListView_createdByTitle = "Created By";
var documentListView_actionsTitle = "Actions";
var documentListView_pageBack = "Back";
var documentListView_pageNext = "Next";
var documentListView_page = "Page";
var documentListView_versionsTitle = "Revisions";
var documentListView_URLHeader = "File Name or URL";
var documentListView_closeButton = "Close";
var documentListView_revisionsTitle = "Revisions";
var documentListView_documentUpdateSuccess = "Document updated successfully.";
var documentListView_documentUpdateFailure = "Document update failed. Contact server administrator for details.";
var documentListView_documentUpdateWarningUpdateContent = "The content cannot be updated on the document because versioning has been disabled. Contact server administrator for details.";
var documentListView_valueRequired = "This value is required.";
var documentListView_loading = "Loading..."

var documentListView_useBPM = "BPM";
var BPMDocServer = "EMBEDDED_ECM_SERVER";
var BPMDocTypeName = "IBM_BPM_Document";

var BPMDocProp_docId = "IBM_BPM_Document_DocumentId";
var BPMDocProp_parentId = "IBM_BPM_Document_ParentDocumentId";
var BPMDocProp_fileType = "IBM_BPM_Document_FileType";
var BPMDocProp_url = "IBM_BPM_Document_FileNameURL";
var BPMDocProp_properties = "IBM_BPM_Document_Properties";
var BPMDocProp_hideInPortal = "IBM_BPM_Document_HideInPortal";
var BPMDocProp_procInstId = "IBM_BPM_Document_ProcessInstanceId";
var BPMDocProp_userId = "IBM_BPM_Document_UserId";
var BPMDocProp_contentMigrated = "IBM_BPM_Document_ContentMigrated";
var BPMDocProp_name = "cmis:name";

var BPMDoc_fileType_file = 'FILE';
var BPMDoc_fileType_url = 'URL';

var requiredBPMDocumentProperties = [BPMDocProp_url,
                                     BPMDocProp_fileType,
                                     BPMDocProp_name,
                                     'cmis:objectId',
                                     'cmis:versionSeriesId'];

var excludeBPMDocumentProperties = [BPMDocProp_docId,
                                    BPMDocProp_parentId,
                                    BPMDocProp_properties,
                                    BPMDocProp_url,
                                    BPMDocProp_fileType,
                                    BPMDocProp_hideInPortal,
                                    BPMDocProp_procInstId,
                                    BPMDocProp_userId,
                                    BPMDocProp_contentMigrated,
                                    'DocumentTitle'];

var resourceBundle;
var documentListUserData = [] ;

var systemPropertyTypeIds = ['cmis:objectId',
                            'cmis:baseTypeId',
                            'cmis:objectTypeId',
                            'cmis:createdBy',
                            'cmis:creationDate',
                            'cmis:lastModifiedBy',
                            'cmis:lastModificationDate',
                            'cmis:changeToken',
                            'cmis:isImmutable',
                            'cmis:isLatestVersion',
                            'cmis:isMajorVersion',
                            'cmis:isLatestMajorVersion',
                            'cmis:versionLabel',
                            'cmis:versionSeriesId',
                            'cmis:isVersionSeriesCheckedOut',
                            'cmis:versionSeriesCheckedOutBy',                            
                            'cmis:versionSeriesCheckedOutId',
                            'cmis:checkinComment',
                            'cmis:contentStreamLength',
                            'cmis:contentStreamMimeType',
                            'cmis:contentStreamFileName',
                            'cmis:contentStreamId',
                            'IsReserved',
                            'IsVersioningEnabled',
                            'MajorVersionNumber',
                            'MinorVersionNumber',
                            'VersionStatus',
                            'ReservationType',
                            'IsInExceptionState'];

function DocumentListControl(documentListLegend, documentListFieldSet, iframe, context) {
	
	this.context = context;
	this.teamworksContextRoot = context.contextRootMap.teamworks;
	this.portalContextRoot = context.contextRootMap.processPortalSupport;
	this.iframe = iframe;
	
	// Get all the translated strings
	this.getResourceBundle();
	
	//Visibility of control
	this.visibility = this.getVisibility(); 
	//Header Label
	if (context.options._metadata.label != undefined) {
		documentListLegend.innerHTML = context.options._metadata.label.get("value");	
	} else {
		documentListLegend.innerHTML = "";
	}
	//Header Tooltip
	if (this.context.options._metadata.helpText != undefined && this.context.options._metadata.helpText.get("value") != "") {
		documentListLegend.title = this.context.options._metadata.helpText.get("value");
	}

	
	this.documentListFieldSet = documentListFieldSet;
	this.documentListLegend = documentListLegend;
	this.documentListTable = getElementByClass( this.documentListFieldSet, "documentListTable");
	this.documentListTable.id = "documentListTable";
	this.documentListDivMsg = getElementByClass( this.documentListFieldSet, "documentListDivMsg");
	
	this.versionsDiv = getElementByClass( this.documentListFieldSet, "versionsDiv");
	this.versionsFieldSet = getElementByClass( this.versionsDiv, "versionsFS bodyBorder");
	this.versionsLegend = getElementByClass( this.versionsFieldSet, "versionsLegend v1blue headerBorder");
	this.versionsTable = getElementByClass( this.versionsDiv, "versionsTable");
	this.versionsDivMsg = getElementByClass( this.versionsDiv, "versionsDivMsg");
		//this.versionsDiv.style.height = 0;
	this.selectedRow; // Currently selected row in the table (<tr>). Used to indicate which row is selected for versions.
	this.versionsCloseButton = getElementByClass( this.versionsFieldSet, "versionsClose");
	this.selectedIndices = new Array(); // selectedIndices[0] contains selected row index. Also used for versions
	
	// Close button for versions
	this.versionsCloseButton.className = "blue";
	this.versionsCloseButton.value = documentListView_closeButton;
	this.versionsCloseButton.innerHTML = documentListView_closeButton;
	this.versionsCloseButton.onclick = dojo.hitch(this, function() {
		this.setVersionsVisibility(false);
	});
	
	this.searchUrl = convertURLtoCurrentSnapshotId(context.options.search.url, this.portalContextRoot);
	this.versionsUrl = convertURLtoCurrentSnapshotId(context.options.getAllDocumentVersions.url, this.portalContextRoot);
	this.getDocumentUrl = convertURLtoCurrentSnapshotId(context.options.getDocument.url, this.portalContextRoot);
	this.getTypeDefUrl = convertURLtoCurrentSnapshotId(context.options.getTypeDefinition.url, this.portalContextRoot);
	this.getTypesUrl = convertURLtoCurrentSnapshotId(context.options.getTypeDescendants.url, this.portalContextRoot);
	
	this.allowCreate = false;
	this.allowUpdate = false;
	this.openInNewWindow = false;
	this.showAllContent = false;

	this.documentsXML; // Set of documents to be displayed in the view

	// Maximum results shown per page (regardless of pagination enabled or not)
	this.maxItems = 10;
	
	this.skipCount = 0; // Number of results to skip for the next query (pagination)
	this.pageNumber = 1; // Which page we are on

	this.useBPMDocuments = "ECM";
	
	this.userId = -1;
	this.associateWithProcessInstance = false;
	this.processInstanceId = -1;
	this.displayMatchRule = "NONE";
	this.displayProperties = "";
	this.displayPropertiesQuery = "";
	this.associateWithProcessInstanceQuery = "";
	this.whereClauseQuery = "";
	
	this.defaultUploadName = "";
	this.userEditable = false;
	this.addProperties = false;
	this.uploadProperties = "";
	this.uploadPropertiesData = new Array();
	this.hideInPortal = false;
	
	this.parentFolderPath = '/';
	this.cmisQuery = "";

	this.reInitializeConfigOptions();
	
	if (this.context.binding) {
		this.dataBinding = this.context.binding.boundObject;
		this.dataBindingList = this.dataBinding.get(this.context.binding.property); 
		this.originalDataBindingList = this.dataBinding.get(this.context.binding.property);
		//items[], listSelectedIndex and listSelected
	}
	
	this.canViewDocuments = false;
	if (this.openInNewWindow || this.dataBinding) 
		this.canViewDocuments = true; // To view documents, user must use new window OR have a databinding specifed
		
	this.canViewVersions = true; // Only false for joint or folder type queries
		
	// Set by setContent().
	this.ecmServerConfigurationName;
	
	// When a selected row is set to the class name 'selected', we use this to back up
	// its regular class name (since just adding the 'selected' name to the list of classes does not display
	// the 'selected' UI.
	this.selectedRowRegularClass;
	
	
	//display loading message
	this.setDocumentListDivMsg(documentListView_loading);

	// Preload the images
	this.initImages();
	
}

/**
 * Create the WHERE clause query for the ECM Server by using displayProperties and associateWithProcessInstance
 * Example: WHERE ((ANY BPM_DOCUMENT_ATTACHMENT_PROPERTIES IN('n1,v1')) AND (ANY BPM_DOCUMENT_ATTACHMENT_PROPERTIES IN('n2,v2')) AND (BPM_DOCUMENT_ATTACHMENT_PROCESS_INSTANCE_ID = '154'))
 */
DocumentListControl.prototype.createWhereClauseQuery = function(displayPropertiesQuery, associateWithProcessInstanceQuery) {
	var query = "";
	
	if(displayPropertiesQuery == "" && associateWithProcessInstanceQuery == "") {
		return query;
	}
	
	var concat = "";
	if(displayPropertiesQuery != "" && associateWithProcessInstanceQuery != "") {
		concat = " AND "
	}
	
	query = "WHERE(" + displayPropertiesQuery + concat + associateWithProcessInstanceQuery + ")";
	
	return query;
}

/**
 * Parses the specific properties provided by the user.
 * There are two types of queries created here depending on the value of matchRule
 * matchRule == ALL : (ANY BPM_DOCUMENT_ATTACHMENT_PROPERTIES IN('n1,v1')) AND (ANY BPM_DOCUMENT_ATTACHMENT_PROPERTIES IN('n2,v2')) ...
 * matchRule == ANY : (ANY BPM_DOCUMENT_ATTACHMENT_PROPERTIES IN('n1,v1' , 'n2,v2' ...))
 */
DocumentListControl.prototype.createDisplayPropertiesQuery = function(properties, matchRule) {
	var query = "";
	
	//validate properties
	var validProperties = this.validateProperties(properties);
	
	//validate params
	if(validProperties.length == 0 || !matchRule || matchRule == "" || matchRule == "NONE") {
		return query;
	}
	
	//get matchRule
	var anyInPrefix = "(ANY " + BPMDocProp_properties + " IN(";
	var anyInPostfix = "))";
	var prefix = "";
	var postfix = "";
	var concat = "";

	if(matchRule == "ALL") {
		prefix = anyInPrefix;
		postfix = anyInPostfix;
		concat = " AND ";
	} else if (matchRule == "ANY") {
		concat = " , ";
	} else {
		return query;
	}
	
	//generate query with valid properties
	var i;
	for(i = 0; i < validProperties.length; i++)
	{
		if(i != 0) {
			query += concat;
		}
		query += prefix + "\'" + validProperties[i].name + "," + validProperties[i].value + "\'" + postfix;
	}
	
	//pad query
	if(query != "") {
		if(matchRule == "ANY") {
			query = anyInPrefix + query + anyInPostfix;
		}
	}
	
	return query;
}

/**
 * Parses the specific properties provided by the user.
 * There type of query created here is as follows
 * associateWithProcessInstance == true : (BPM_DOCUMENT_ATTACHMENT_PROCESS_INSTANCE_ID = '154')
 * associateWithProcessInstance == false : ""
 */
DocumentListControl.prototype.createAssociateWithProcessInstanceQuery = function(associateWithProcessInstance, processInstanceId) {
	var query = "";
	
	if(!associateWithProcessInstance || associateWithProcessInstance != true || 
			!processInstanceId || processInstanceId == -1) {
		return query;
	}
	
	query = "(" + BPMDocProp_procInstId + " = " + processInstanceId + ")";
	
	return query;
}

/**
 * Parses the specific properties provided by the user.
 * These properties will later be added to the document created using the create document dialog 
 */
DocumentListControl.prototype.createUploadPropertiesData = function(properties, addProperties) {
	var uploadPropertiesData = new Array();
	
	if(addProperties == false) {
		return uploadPropertiesData;
	}
	
	//validate properties
	var validProperties = this.validateProperties(properties);
	
	//validate params
	if(validProperties.length == 0) {
		return uploadPropertiesData;
	}
	
	//generate uploadProperties with valid properties
	var i;
	for(i = 0; i < validProperties.length; i++)
	{
		uploadPropertiesData.push(validProperties[i].name + "," + validProperties[i].value);
	}
	
	return uploadPropertiesData;
}

/**
 * Validates the array of properties passed to it and returns a validated array.
 */
DocumentListControl.prototype.validateProperties = function(properties) {
	var validProperties = new Array();
	
	//properties passed in from a preset variable in the coach configuration 
	//tab are stored in a list so this case needs to be handled
	if(properties.items) {
		properties = properties.items;
	}
	
	if(!properties || properties == null || properties == "" || 
			!properties.length || properties.length == 0) {
		return validProperties;
	}
	
	for(i = 0; i < properties.length; i++)
	{
		if(properties[i].name && properties[i].value 
				&& properties[i].name != "" && properties[i].value != "") {
			validProperties.push(properties[i]);
		}
	}
	
	return validProperties;
}

/**
 * Gets the new values of the configuration options when the document list view is refreshed.
*/
DocumentListControl.prototype.reInitializeConfigOptions = function() {
	
	this.updateVisibility();
	
	this.allowCreate = (this.context.options.allowCreate && this.visibility!="READONLY") ? this.context.options.allowCreate.get("value") : false;
	this.allowUpdate = (this.context.options.allowUpdate && this.visibility!="READONLY") ? this.context.options.allowUpdate.get("value") : false;
	this.openInNewWindow = this.context.options.openInNewWindow ? this.context.options.openInNewWindow.get("value") : false;
	this.showAllContent = this.context.options.showAllContent ? this.context.options.showAllContent.get("value") : false;
	// Maximum results shown per page (regardless of pagination enabled or not)
	this.maxItems = (this.context.options.numberOfResultsToShow && this.context.options.numberOfResultsToShow.get("value") > 0) ? this.context.options.numberOfResultsToShow.get("value") : 10;
	
	//this will determine the type of ecm server being used (BPM Documents / ECM Documents)
	this.useBPMDocuments = this.context.options.useBPMDocuments ? this.context.options.useBPMDocuments.get("value") : "ECM";
	
	if(this.useBPMDocuments == documentListView_useBPM) {
		this.bpmDocumentOptions = this.context.options.bpmDocumentOptions ? this.context.options.bpmDocumentOptions.get("value") : null;
		
		if(this.bpmDocumentOptions != null) {
			//display options
			this.displayOptions = this.bpmDocumentOptions.displayOptions ? this.bpmDocumentOptions.displayOptions : null;

			if(this.displayOptions != null) {
				this.userId = this.context.bpm.system.user_id ? this.context.bpm.system.user_id : -1;
				this.associateWithProcessInstance = this.displayOptions.associatedWithProcessInstance ? this.displayOptions.associatedWithProcessInstance : false;
				this.processInstanceId = this.context.bpm.system.instanceId ? this.context.bpm.system.instanceId : -1;
				this.displayMatchRule = this.displayOptions.displayMatchRule ? this.displayOptions.displayMatchRule : "";
				this.displayProperties = this.displayOptions.displayProperties ? this.displayOptions.displayProperties : "";
				this.displayPropertiesQuery = this.createDisplayPropertiesQuery(this.displayProperties, this.displayMatchRule);
				this.associateWithProcessInstanceQuery = this.createAssociateWithProcessInstanceQuery(this.associateWithProcessInstance, this.processInstanceId);
				this.whereClauseQuery = this.createWhereClauseQuery(this.displayPropertiesQuery, this.associateWithProcessInstanceQuery);
			}
			
			//upload options
			this.uploadOptions = this.bpmDocumentOptions.uploadOptions ? this.bpmDocumentOptions.uploadOptions : null;

			if(this.uploadOptions != null) {
				this.defaultUploadName = this.uploadOptions.defaultUploadName ? this.uploadOptions.defaultUploadName : "";
				this.userEditable = this.uploadOptions.userEditable ? this.uploadOptions.userEditable : false;
				this.addProperties = this.uploadOptions.addProperties ? this.uploadOptions.addProperties : false;
				this.uploadProperties = this.uploadOptions.uploadProperties ? this.uploadOptions.uploadProperties : "";
				this.uploadPropertiesData = this.createUploadPropertiesData(this.uploadProperties, this.addProperties);
				this.hideInPortal = this.uploadOptions.hideInPortal ? this.uploadOptions.hideInPortal : false;
			}
		}
		//set cmisQuery the required properties of IBM BPM Documents configuration
		this.parentFolderPath = '/';
		this.cmisQuery = "SELECT cmis:name, " + BPMDocProp_url + ", MajorVersionNumber, cmis:lastModificationDate, "+ BPMDocProp_userId +", " + BPMDocProp_fileType + ", cmis:objectId, cmis:versionSeriesId FROM " + BPMDocTypeName + " " + this.whereClauseQuery + " ORDER BY cmis:name ASC";
	}
	else {
		//this.useBPMDocuments == "ECM"
		this.cmisDocumentOptions = this.context.options.cmisDocumentOptions ? this.context.options.cmisDocumentOptions.get("value") : null;
		
		if(this.cmisDocumentOptions != null) {
			this.parentFolderPath = this.cmisDocumentOptions.parentFolderPath ? this.cmisDocumentOptions.parentFolderPath : '/';
			this.cmisQuery = this.cmisDocumentOptions.cmisQuery ? this.cmisDocumentOptions.cmisQuery : "";
		}
		
		if(this.cmisQuery == null || this.cmisQuery == ""){
			this.cmisQuery = this.context.options.cmisQuery ? this.context.options.cmisQuery.get("value") : "";
		}
		
		if(this.parentFolderPath == null || this.parentFolderPath == '/'){
			this.parentFolderPath = this.context.options.parentFolderPath ? this.context.options.parentFolderPath.get("value") : '/';
		}
			
	}

	this.cmisQuery = encodeURIComponent(this.cmisQuery);
}

/**
 * Set header visibility (needs to be called from the 'view' function, since
 * this context.options._metadata.visibility won't be set at 'load' time
 */
DocumentListControl.prototype.setHeaderVisibility = function() {
	
	if (this.context.options._metadata.labelVisibility != undefined &&
		// Hide header if inside a tab or table
		this.context.options._metadata.labelVisibility.get("value") == "NONE") {
			dojo.style(this.documentListLegend, "display", "none");
	} else {
		// show the border otherwise
		this.documentListFieldSet.className += " bodyBorder";
	}
}

/**
 * Get the visibility setting from control properties
 */
DocumentListControl.prototype.getVisibility = function() {
    var visibility = "DEFAULT";
    if (this.context.options._metadata.visibility) {
        visibility = this.context.options._metadata.visibility.get("value");
    }

    if (visibility == "DEFAULT") {
        visibility = this.context.getInheritedVisibility();
    }
	
	return visibility;
}

/**
 * 
 */
DocumentListControl.prototype.updateVisibility = function() {
	//Visibility of control
	this.visibility = this.getVisibility(); 
	
	if (this.visibility == "NONE") {
    	this.context.setDisplay(false);
		return;
    } else {
    	this.context.setDisplay(true);
    }
	
	if (this.visibility == "HIDDEN") {
        this.context.setVisibility(false);
    } else {
        this.context.setVisibility(true);
    }
	 
}

/**
* Clears doc list msg
*/
DocumentListControl.prototype.clearDocumentListDivMsg = function() {
	this.documentListDivMsg.style.visibility="collapse";
	this.documentListDivMsg.innerHTML = "";
}

/**
* sets doc list msg
*/
DocumentListControl.prototype.setDocumentListDivMsg = function(message) {
	if(this.visibility != "NONE" && this.visibility != "HIDDEN"){
		this.documentListDivMsg.style.visibility="visible";
		this.documentListDivMsg.innerHTML = message;
	}else{
		this.clearDocumentListDivMsg();
	}
}


/**
* Clears versions msg
*/
DocumentListControl.prototype.clearVersionsDivMsg = function() {
	this.versionsDivMsg.innerHTML = "";
}

/**
* sets versions msg
*/
DocumentListControl.prototype.setVersionsDivMsg = function(message) {
	this.versionsDivMsg.innerHTML = message;
}


/**
* Set the current row to selected
*/
DocumentListControl.prototype.setRowAsSelected = function(row) {
	this.clearSelectedRow(); 
	this.selectedRow = row;
	this.selectedRowRegularClass = row.className;
	row.className = "selected";
	//dojo.addClass(row, "selected");
}

/**
* sets doc list msg
*/
DocumentListControl.prototype.clearSelectedRow = function() {
	if (this.selectedRow) 
		this.selectedRow.className = this.selectedRowRegularClass;
		//dojo.removeClass(this.selectedRow, "selected");
}

/**
 * documentListUserData will be a list of user ids and the associated fullNames. eg, [1:sample, 2:sample2]
 */
DocumentListControl.prototype.setDocumentListUserData = function() {

	//When using BPM Documents we need to obtain a list of users in order to resolve a user id to a user name for created documents
	if(this.useBPMDocuments == documentListView_useBPM) {
		//documentListUserData should only be at 0 if it has not been instantiated yet. 
		if(documentListUserData.length == 0) {
			
			var rest_url = "/rest/bpm/wle/v1/users?includeTaskExperts=true&sort=true&includeInternalMemberships=true&parts=all";
			dojo.xhr.get({
				url: rest_url,
				sync: true, 
				handleAs: 'json',
				headers: { "Content-Type": "application/json", "Accept": "application/json"},
				load: function(data, args) {
					var sample;
					var userIds = data.data.users;
					
					for (var item in userIds) {
						documentListUserData[userIds[item].userID] = userIds[item].fullName;
					}
				} 
			});
		}
	}
}


/**
* Loads list of documents returned by querying searchURL. 
*/
DocumentListControl.prototype.loadDocumentList = function() {
	
	this.setDocumentListUserData();
	
	this.setVersionsVisibility(false); // Hide versions when loadDocumentList is first called
	
	inputParameters='<input name=\"elementValue\">'; 
	inputParameters+='<variable name=\"cmisQuery\">'+this.cmisQuery+'</variable>'
	inputParameters+='<variable name=\"maxItems\">'+this.maxItems+'</variable>'
	inputParameters+='<variable name=\"skipCount\">'+this.skipCount+'</variable>';
	inputParameters+='<variable name=\"searchAllVersions\">false</variable>';
	inputParameters+='<variable name=\"useBPMDocuments\">'+this.useBPMDocuments+'</variable>';
	inputParameters+='</input>';

	var searchURL = this.searchUrl + '&input=' + inputParameters;
	
	 dojo.xhrGet({
        url: searchURL,
        handleAs: "xml",
        load: dojo.hitch(this, function(xmlDoc) {
			try {
				this.documentsXML=xmlDoc;
				this.displayContent();
				
			} catch (e) {
				alert(e);
			} finally {
				this.initDocumentDialog();
			}
        }),
        error: dojo.hitch(this, function(o) {
        	alert(documentListView_documentSearchError);
        })
    });
	
}

/**
 * Show (true) or hide (false) the versions table
 */
DocumentListControl.prototype.setVersionsVisibility = function(visibility) {
	if (visibility == true) {
		dojo.style(this.versionsFieldSet, "display", "block");
	} else {
		this.clearSelectedRow();
		dojo.style(this.versionsFieldSet, "display", "none");
	}
		
}

/**
* Loads versions of documents for the given documentId
*/
DocumentListControl.prototype.loadVersionList = function(versionSeriesId, documentId) {

	this.setVersionsVisibility(true);
	this.clearVersionsDivMsg();
	
	inputParameters='<input name=\"elementValue\"><variable name=\"versionSeriesId\" type=\"String\">' + versionSeriesId + '</variable><variable name=\"serverName\" type=\"String\">' + this.ecmServerConfigurationName + '</variable></input>'; 
	
	var versionsURL = this.versionsUrl + '&input=' + inputParameters;
	
	 dojo.xhrGet({
        url: versionsURL,
        handleAs: "xml",
        load: dojo.hitch(this, function(xmlDoc) {
			try {
				
				if(xmlDoc == null){
					this.loadVersionListUsingDocumentId(documentId);
				}else
					this.displayVersions(xmlDoc);
				
			} catch (e) {
				alert(e);
			}
        }),
        error: dojo.hitch(this, function(o) {
        	alert(documentListView_documentVersionsError);
        })
    });
	
}

DocumentListControl.prototype.loadVersionListUsingDocumentId = function(documentId) {

	this.setVersionsVisibility(true);
	this.clearVersionsDivMsg();
	
	inputParameters='<input name=\"elementValue\"><variable name=\"documentId\" type=\"String\">' + documentId + '</variable><variable name=\"serverName\" type=\"String\">' + this.ecmServerConfigurationName + '</variable></input>'; 
	
	var versionsURL = this.versionsUrl + '&input=' + inputParameters;
	
	 dojo.xhrGet({
        url: versionsURL,
        handleAs: "xml",
        load: dojo.hitch(this, function(xmlDoc) {
			try {
				
				this.displayVersions(xmlDoc);
				
			} catch (e) {
				alert(e);
			}
        }),
        error: dojo.hitch(this, function(o) {
        	alert(documentListView_documentVersionsError);
        })
    });
	
}

/**
* Clears the items in databinding list, between start (inclusive) to end of list
* if start is undefined, then clears entire list
*/
DocumentListControl.prototype.clearDatabindingList = function(start) {
	if (this.dataBindingList == undefined) return;
	
	if (start == undefined) {
		start=0;
	}
	
	for (i=this.dataBindingList.length(); i>start; i--) {
		this.dataBindingList.remove(i-1);
	}
}

DocumentListControl.prototype.clearOriginalDataBindingList = function(start) {
	if (this.originalDataBindingList == undefined) return;
	
	if (start == undefined) {
		start=0;
	}
	
	for (i=this.originalDataBindingList.length(); i>start; i--) {
		this.originalDataBindingList.remove(i-1);
	}
}

/**
* Builds a table based on this.content
*/
DocumentListControl.prototype.displayVersions = function( versionsXML ) {
	var d, propertyMetadata,propertyMetadataItems, row, rowItems;
	
	table=this.versionsTable;
	while(table.hasChildNodes())
	{
		table.removeChild(table.firstChild);
	}
		
	// Check for errors during the query
	if (versionsXML == undefined || versionsXML == null) {
		this.setVersionsDivMsg(documentListView_documentVersionsError);
		return;
	}
	
	// Clear databinding list starting at maxitems (so any previous revisions added to the databinding list are cleared)
	this.clearDatabindingList(this.maxItems);
	if(this.dataBindingList != this.originalDataBindingList)
		this.clearOriginalDataBindingList(this.maxItems);
	// Print table headers
	thr=createAndAppendChildElement('tr', table,"");
	createAndAppendChildElementWithText('th', thr, "", documentListView_revisionTitle);
	createAndAppendChildElementWithText('th', thr, "", documentListView_fileNameTitle);
	createAndAppendChildElementWithText('th', thr, "", documentListView_revisionDateTitle);
	createAndAppendChildElementWithText('th', thr, "", documentListView_createdByTitle);
	
	
	// Print table body 
	ecmDocument = versionsXML.getElementsByTagName("variable")[0];
	var rowItems = ecmDocument.childNodes; 
	var rowClass = "odd";
	
	for (i=0; i<rowItems.length; i++) {
		
		if (rowItems[i].nodeType != 1) continue; // Ignore text nodes which show up as children!
		
		tr = createAndAppendChildElement('tr', table, rowClass);
		rowClass = switchOddEven(rowClass);
		
		createAndAppendChildElementWithText('td', tr, "", rowItems[i].getElementsByTagName("versionLabel")[0].childNodes[0].data);
		tdName = createAndAppendChildElementWithText('td', tr, "","");
		
		// Create link or not
		try {
			var bpmContentUrl = null;
			var bpmFileType = null;
			
			if(this.useBPMDocuments == documentListView_useBPM) {
				var properties = rowItems[i].getElementsByTagName("properties")[0];
				var items = properties.getElementsByTagName("item");
				for(var j = 0; j < items.length; j++) {
					var property = items[j].getElementsByTagName('objectTypeId')[0];
					var value = items[j].getElementsByTagName('value')[0];
					if(property && property.childNodes[0].data && value && value.childNodes[0].data) {
						if(property.childNodes[0].data == BPMDocProp_url) {
							bpmContentUrl = value.childNodes[0].data;
						}
						if(property.childNodes[0].data == BPMDocProp_fileType) {
							bpmFileType = value.childNodes[0].data;
						}
					}
				}
			}
			
			ECMDocumentVersionInfo = new Object();
			if(bpmFileType != null && bpmFileType == BPMDoc_fileType_url) {
				ECMDocumentVersionInfo.contentURL = buildURLString(this.portalContextRoot) + bpmContentUrl;
			} else {
				ECMDocumentVersionInfo.contentURL = buildDocumentURLString(this.searchUrl, this.ecmServerConfigurationName, this.portalContextRoot) + rowItems[i].getElementsByTagName("objectId")[0].childNodes[0].data;
			}
			
			if (this.dataBinding) {
				if(this.dataBindingList != this.originalDataBindingList)
					this.originalDataBindingList.add(ECMDocumentVersionInfo);
				this.dataBindingList.add(ECMDocumentVersionInfo);
			}
			
			if (this.openInNewWindow == false) {
				currentRevisionNode = this.dataBindingList.length()-1;
			}
			
		} catch (e) {
			// In some cases, there is no document url returned (there is no document content)
			ECMDocumentVersionInfo = null;
		}
		
		if (this.canViewDocuments && ECMDocumentVersionInfo != null) {
		
			var previewLink = createAndAppendChildElement('a', tdName, "classRevisionsLink");
			previewLink.innerHTML = rowItems[i].getElementsByTagName("name")[0].childNodes[0].data;
				
			
			if (this.openInNewWindow == true) {
				previewLink.onclick =  dojo.hitch(this, this.openLinkInNewWindow, ECMDocumentVersionInfo.contentURL, false, undefined);
			} else { 
				previewLink.onclick =  dojo.hitch(this, this.setSelectionInBinding, currentRevisionNode, false, undefined);
			}
			
			
		} else {
			createAndAppendChildElementWithText('span', tdName, "", rowItems[i].getElementsByTagName("name")[0].childNodes[0].data);
		}
		
			
		createAndAppendChildElementWithText('td', tr, "", rowItems[i].getElementsByTagName("creationDate")[0].childNodes[0].data);
		createAndAppendChildElementWithText('td', tr, "", rowItems[i].getElementsByTagName("createdBy")[0].childNodes[0].data);
		
	}
	
}


/*
 * Opens url in new window
 */
DocumentListControl.prototype.openLinkInNewWindow = function(url, hideVersions, currentTableRow) {
	
	this.setVersionsVisibility(!hideVersions); // Hide versions 
	if(currentTableRow != undefined)
		this.setRowAsSelected(currentTableRow);
		
	// Replace whitespaces for title in IE
	if(isBrowserIE())
		var title = documentListView_documentContentView.replace(/\s/g, "");
	else
		var title = documentListView_documentContentView;
	window.open(url, title);

}

/*
 * Sets selected row index in binding
 */
DocumentListControl.prototype.setSelectionInBinding = function( rowIndex, hideVersions, currentTableRow) {
					
	if (this.dataBinding) {
		
		this.setVersionsVisibility(!hideVersions); // Hide versions 
		if(currentTableRow != undefined)
			this.setRowAsSelected(currentTableRow);
		this.selectedIndices[0]=rowIndex;
		this.originalDataBindingList.set("listAllSelectedIndices", this.selectedIndices);
	}
			

}

/**
 * Disables create, update, view and revisions
 */
DocumentListControl.prototype.disableAllActions = function() {
	this.allowCreate = false;
	this.allowUpdate = false;
	this.canViewDocuments = false;
	this.canViewVersions = false;
}

/* Initialize the images used in the views */
DocumentListControl.prototype.initImages = function() {
	this.navNextImg = new Image();
	this.navNextImg.src = this.teamworksContextRoot +'/images/ECM/next.png';
	this.navNextImgHover = new Image();
	this.navNextImgHover.src = this.teamworksContextRoot +'/images/ECM/next_hover.png';
	
	this.navPrevImg = new Image();
	this.navPrevImg.src = this.teamworksContextRoot +'/images/ECM/prev.png';
	this.navPrevImgHover = new Image();
	this.navPrevImgHover.src = this.teamworksContextRoot +'/images/ECM/prev_hover.png';
	
	this.navPreviewImg = new Image();
	this.navPreviewImg.src = this.teamworksContextRoot +"/images/ECM/ecm_viewdocument_image.png" 
	this.navPreviewImgHover = new Image();
	this.navPreviewImgHover.src = this.teamworksContextRoot +"/images/ECM/ecm_viewdocument_hover_image.png" 
	
	this.navPreviewImg = new Image();
	this.navPreviewImg.src = this.teamworksContextRoot +"/images/ECM/ecm_viewdocument_image.png" 
	this.navPreviewImgHover = new Image();
	this.navPreviewImgHover.src = this.teamworksContextRoot +"/images/ECM/ecm_viewdocument_hover_image.png" 

	this.navEditImg = new Image();
	this.navEditImg.src = this.teamworksContextRoot +"/images/ECM/ecm_updatedocument_image.png" 
	this.navEditImgHover = new Image();
	this.navEditImgHover.src = this.teamworksContextRoot +"/images/ECM/ecm_updatedocument_hover_image.png" 
	
	this.navRevisionImg = new Image();
	this.navRevisionImg.src = this.teamworksContextRoot +"/images/ECM/ecm_documentversions_image.png" 
	this.navRevisionImgHover = new Image();
	this.navRevisionImgHover.src = this.teamworksContextRoot +"/images/ECM/ecm_documentversions_hover_image.png" 
}
	

/**
 * Builds a table based on this.documentsXML
 */
DocumentListControl.prototype.displayContent = function() {
	var d, propertyMetadata,propertyMetadataItems, data, dataItems, row, rowItems;
	var isStronglyTyped = false;
	var columnNames = new Array();
	var documentId = null, documentUrl = null, idColumn=-1; // Column containing cmis:objectId
	var versionSeriesId = null, seriesIdColumn=-1; // Column containing cmis:versionSeriesId
	var bpmContentURL = null, idUrlColumn=-1; // Column containing URL
	var bpmFileType = null, idFileTypeColumn=-1; // Column containing FileType
	var idUserIds = -1;// Column containing user Ids
	var totalColumns=0; // Number of columns in search results
	var currentRow=0; // Row that we are building (used to set selection index for databinding)
	var idNameColumn=-1; // Column containing the document name
	
	this.versionsCloseButton.value = documentListView_closeButton;
	this.versionsCloseButton.innerHTML = documentListView_closeButton;
	
	this.versionsLegend.innerHTML = documentListView_versionsTitle;
	
	// Check for errors during the query.
	if (this.documentsXML == undefined || this.documentsXML == null || this.documentsXML.getElementsByTagName('serverName').length == 0) {
		this.setDocumentListDivMsg(documentListView_documentSearchError);
		this.disableAllActions();
		return;
	}
	
	if(this.useBPMDocuments == documentListView_useBPM) {
		//when using bpm documents the objectTypeId must be of type 'BPMDocTypeName'
		var docType = this.documentsXML.getElementsByTagName('objectTypeId')[0];
		if(!docType || !docType.firstChild.data || docType.firstChild.data != BPMDocTypeName) {
			this.setDocumentListDivMsg(documentListView_documentSearchError);
			this.disableAllActions();
			return;
		}
		
		//also, there may be a custom query used in the content integration node so need to verify
		//that the content server has returned the minimum properties required to display the table
		var properties = this.documentsXML.getElementsByTagName('queryName');
		var propertiesList = [];
		for(var i = 0; i < properties.length; i++) {
			propertiesList.push(properties[i].firstChild.data);
		}
		
		var missingProperties = undefined;
		for(var i = 0; i < requiredBPMDocumentProperties.length; i++) {
			if(indexOf(propertiesList, requiredBPMDocumentProperties[i]) == -1) {
				if(missingProperties == undefined)
					missingProperties = requiredBPMDocumentProperties[i];
				else
					missingProperties += " ," + requiredBPMDocumentProperties[i];
					
			}
		}
		
		if(missingProperties != undefined){
			this.setDocumentListDivMsg(dojo.string.substitute(documentListView_documentSearchError_missingProperties, [missingProperties]));
			this.disableAllActions();
			return;
		}
	}
	
	this.clearDocumentListDivMsg(); // Clears messages
	
	this.clearDatabindingList(); 
	if(this.dataBindingList != this.originalDataBindingList)
		this.clearOriginalDataBindingList(); 
	
	
	// If objectTypeId does not exist in search result (even if it should), we default to cmis:document
	objTypeTag = this.documentsXML.getElementsByTagName('objectTypeId')[0];
	
	if(objTypeTag) {
		this.selectedObjectTypeId = this.documentsXML.getElementsByTagName('objectTypeId')[0].childNodes[0].data;
	} else {
		// If object *type* id is not available, that means it is likely because the query is JOINED. No actions can be performed as
		// we don't know the type
		this.selectedObjectTypeId = 'cmis:document';
		this.disableAllActions();
	}

	if (this.selectedObjectTypeId == "cmis:folder") {
		// Disable all actions as none of them can be performed on folders
		// TODO: What about sub folder types
		this.disableAllActions();
	}
	
	this.ecmServerConfigurationName = this.documentsXML.getElementsByTagName('serverName')[0].childNodes[0].data;
	var hasMoreItems = this.documentsXML.getElementsByTagName('hasMoreItems')[0].childNodes[0].data;
	 
	var documentURLString = buildDocumentURLString (this.searchUrl, this.ecmServerConfigurationName, this.portalContextRoot);
	
	table=this.documentListTable;
	while(table.hasChildNodes())
	{
		table.removeChild(table.firstChild);
	}
	
	// Print table headers
	propertyMetadata=this.documentsXML.getElementsByTagName('propertyMetadata'); 
	propertyMetadataItems = propertyMetadata[0].getElementsByTagName('item'); //There is always 1 propertyMetadata tag in result (even when there are 0 results) 
	numItems = this.documentsXML.getElementsByTagName('numItems')[0].childNodes[0].data;;
	
	// Check for 0 results
	if (numItems == 0) {
		this.setDocumentListDivMsg(documentListView_noDocumentsFound);
		return;
	}
	
	thr=createAndAppendChildElement('tr', table,"");
	for (i=0; i<propertyMetadataItems.length; i++) {
	
		columnNames[i] = propertyMetadataItems[i].getElementsByTagName('queryName')[0].childNodes[0].data;
		
		//Identify which column contains the ids, but avoid creating that column
		if (columnNames[i] == 'cmis:objectId') { // TODO: 'cmis:objectId') {
			idColumn = i;
			continue;
		}
		
		//Identify which column contains the version series ids, but avoid creating that column
		if (columnNames[i] == 'cmis:versionSeriesId') { 
			seriesIdColumn = i;
			continue;
		}
		
		if(this.useBPMDocuments == documentListView_useBPM) {
			//IDentify name column
			if (columnNames[i] == BPMDocProp_name) {
				idNameColumn = i;
			}
			
			//Identify which column contains the FileTypes
			if (columnNames[i] == BPMDocProp_fileType) {
				idFileTypeColumn = i;
				continue;
			}
			
			//identify which column contains the user Ids
			if (columnNames[i] == BPMDocProp_userId) {
				idUserIds = i;
			}
			
			//Identify which column contains the URLs
			if (columnNames[i] == BPMDocProp_url) {
				idUrlColumn = i;
			}
		}
		
		var displayName;
		
		try {
			var displayNameNode = propertyMetadataItems[i].getElementsByTagName('displayName')[0];
			
			displayName = displayNameNode.childNodes[0].data
			
		} catch (e) { 
		    //if document content is empty the url display name will not be passed in.
		    if(i == idUrlColumn){
		        displayName = documentListView_URLHeader;   
		    }
		    else{
			// Do nothing. Will use query name
			displayName = columnNames[i];
		}
		}
		
		createAndAppendChildElementWithText('th', thr, "", displayName); // childNodes[0].data displays the text inside CDATA
		
	}
	//Add the Actions Column
	createAndAppendChildElementWithText('th', thr, "", documentListView_actionsTitle);
	
	// Print table body 
	row=this.documentsXML.getElementsByTagName('row')[0]; //Assume only 1 rows tag in result.
	if (row.length == 0) return;
	rowItems = row.childNodes; 
	rowClass = "odd";
	
	for (i=0; i<rowItems.length; i++) {
		

		if (rowItems[i].nodeType != 1 ) continue; // Ignore text nodes which show up as children!		
		if (rowItems[i].getAttribute("type") == "ECMSearchResultRow") {
			/* For generic search results:
				<row type="ECMSearchResultRow[]"> 	----> row: one per search query
				  <item type="ECMSearchResultRow">	----> rowItem[i]
					<column type="ANY[]">			----> data
					  <item type="String"><![CDATA[Detail Deployment Log]]></item>		----> dataItems[i]
					  <item type="String"><![CDATA[idd_E4C06613-4F88-4DAA-B4F0-A8102D7B47D7]]></item>
					  <item type="ECMMultiValue">	----> Special case, see below
						<value type="ANY[]">
						  <item type="Boolean"><![CDATA[true]]></item>
						  <item type="Boolean"><![CDATA[false]]></item>
						  <item type="Boolean"><![CDATA[true]]></item>
						</value>
					  </item>
					</column>
				  </item>
				  <item>
					...
			 */
			data = rowItems[i].getElementsByTagName('column')[0];
			dataItems = data.childNodes;
		} else {
			/* For strongly typed search results:
				<row type="ECMResultBO[]">			----> row: one per search query
				  <item type="ECMResultBO" />       ----> empty column values
				  <item type="ECMResultBO">			----> rowItem[i]
					<booleanProperty type="Boolean"><![CDATA[true]]></booleanProperty>	----> dataItems[i]
					<idProperty type="ECMID"><![CDATA[{ABABABAB-FDCF-4FF4-84A0-E1010A2313D3}]]></idProperty>
				  </item>
				  <item>
					...
			 */
			if (rowItems[i].childElementCount == 0) continue; //Empty column values. See e.g. above.
			isStronglyTyped = true;
			dataItems = rowItems[i].childNodes;
		}
		
		tr=createAndAppendChildElement('tr', table, rowClass);
		rowClass = switchOddEven(rowClass);
		totalColumns=0; 
		
		if (isStronglyTyped) {
		
			// TODO: IDs!
			
			// Values in the same order as BO parameters
			for (j=0; j<columnNames.length; j++) {
				dataContent = rowItems[i].getElementsByTagName(columnNames[j])[0].childNodes[0].data;
				createAndAppendChildElementWithText('td', tr, "", dataContent);
				totalColumns++;
			}
			
		} else {
			// Values same order as column names
			for (j=0; j<dataItems.length; j++) {
				if (dataItems[j].nodeType != 1) continue; // Ignore text nodes which show up as children

				var isBPMUrl = false;
				if(this.useBPMDocuments == documentListView_useBPM) {
					if (totalColumns == idUrlColumn) {
						if(dataItems[j].childNodes[0]) {
							bpmContentURL = htmlStringDecoder(dataItems[j].childNodes[0].data);
							isBPMUrl = true;
						}
					}
					if (totalColumns == idFileTypeColumn) {
						if(dataItems[j].childNodes[0]) {
							bpmFileType = dataItems[j].childNodes[0].data;
						}
						totalColumns++;
						continue; // don't show the idFileTypeColumn which just contains the file type
					}
					
					if (totalColumns == idUserIds) {
						if(dataItems[j].childNodes[0]) {
							var fullName = documentListUserData[dataItems[j].childNodes[0].data];
							
							if(fullName != undefined){
								dataItems[j].childNodes[0].data = fullName;
							}
						}
					}
				}

				// Use 'totalColumns' (instead of 'j') to compare against 'idColumn'
				// since j includes text node numbers
				if (totalColumns == idColumn) {
					documentId = dataItems[j].childNodes[0].data;//.substring(4);
					documentUrl = documentURLString + documentId;
					totalColumns++;
					continue; // don't show the idColumn which just contains ids
				}
				
				// Use 'totalColumns' (instead of 'j') to compare against 'seriesIdColumn'
				// since j includes text node numbers
				if (totalColumns == seriesIdColumn) {
					versionSeriesId = dataItems[j].childNodes[0].data;//.substring(4);
					totalColumns++;
					continue; // don't show the seriesIdColumn which just contains ids
				}
				
				dataContent = "";
				if(dataItems[j].getAttribute("type") =="ECMMultiValue") {
					dataContent = formatMultiValue(dataItems[j]);
				} else {
					if (dataItems[j].hasChildNodes()) // Could be an empty item, if there is no value available ( <item type="ANY" /> )
						dataContent = dataItems[j].childNodes[0].data;
				}
				
				if(isBPMUrl == true || idNameColumn == totalColumns){
					dataContent = htmlStringDecoder(dataContent);
				}
				
				createAndAppendChildElementWithText('td', tr, "", dataContent);
				totalColumns++;
				
			}
		}

		//Set up the ECMDocumentInfo link: either link to document or url (url is used with IBM BPM Documents)
		ECMDocumentInfo = new Object();
		
		if(bpmFileType != null && bpmFileType == BPMDoc_fileType_url) {
			ECMDocumentInfo.contentURL = buildURLString(this.portalContextRoot) + bpmContentURL;
			bpmContentURL = null;
			bpmFileType = null;
		} else {
			ECMDocumentInfo.contentURL = documentUrl;
			documentUrl = null;
		}
	
		if (this.dataBinding) {
			if(this.dataBindingList != this.originalDataBindingList)
				this.originalDataBindingList.add(ECMDocumentInfo);
			this.dataBindingList.add(ECMDocumentInfo); // Add ECMDocumentInfo to the databinding list
		}
		
		// Add Action Column Icons
		tdActions = createAndAppendChildElement('td', tr, "classActionsTd");
		totalColumns++;
		createAndAppendChildElementWithText('span', tdActions, "", " ");
		
		
		// 1. Preview Icon
		if (this.canViewDocuments && documentId != undefined ) {
			var previewIcon = createAndAppendChildElement('a', tdActions, "");
			this.createHoverLink(previewIcon, this.navPreviewImg, this.navPreviewImgHover, "", false, documentListView_viewDoc, 16, 16);
			
			if (this.openInNewWindow == true) {
				previewIcon.onclick = dojo.hitch(this, this.openLinkInNewWindow, ECMDocumentInfo.contentURL, true, tr);
				//Note: Must pass arguments into hitch separately (by copy). If you refer to parameter values outside directly, it will return latest value at the end of the for loop (since it uses reference) rather than the snapshot of the value at this point in the loop 
			} else { 
				previewIcon.onclick = dojo.hitch(this, this.setSelectionInBinding, currentRow, true, tr);
			}
			
		} else if (this.canViewDocuments && documentId == undefined) {
			// (Custom) Query did not return document Id even though user wants to use it. 
			var previewIcon = createAndAppendChildElement('img', tdActions, "");
			previewIcon.src= this.teamworksContextRoot +"/images/ECM/ecm_viewdocumentdisabled_image.png" 
			previewIcon.height=16; 
			previewIcon.width=16;
			previewIcon.title=documentListView_noIdError; 
			createAndAppendChildElementWithText('span', tdActions, "", " ");
		}
		
		// 2. Update Icon
		var updateArgs=new Array();
		updateArgs[0] = documentId;
		
		if (this.allowUpdate && documentId != undefined ) {
			var editIcon = createAndAppendChildElement('a', tdActions, "");
			this.createHoverLink(editIcon, this.navEditImg, this.navEditImgHover, "", false, documentListView_updateDoc_link, 16, 16);
				
			editIcon.onclick = dojo.hitch(this, function(docId) {
				
				this.setVersionsVisibility(false); // Hide versions 
				this.openUpdateDocumentDialog(docId);
				
			}, documentId);
			
		} else if (this.allowUpdate && documentId == undefined) {
			// (Custom) Query did not return document Id even though user wants to use it. 
			var editIcon = createAndAppendChildElement('img', tdActions, "");
			editIcon.src=this.teamworksContextRoot +"/images/ECM/ecm_updatedocument_disabled_image.png" 
			editIcon.height=16; 
			editIcon.width=16;
			editIcon.title=documentListView_noIdError; 
			createAndAppendChildElementWithText('span', tdActions, "", " ");
		}
		
		// 3. Versions Icon
		if(versionSeriesId == undefined) // Legacy apps support
			versionSeriesId = documentId;
		
		if (this.canViewVersions && versionSeriesId != undefined ) {
			var versionsIcon = createAndAppendChildElement('a', tdActions, "");
			this.createHoverLink(versionsIcon, this.navRevisionImg, this.navRevisionImgHover, "", false, documentListView_versionsTitle, 16, 16);
		
			versionsIcon.onclick = dojo.hitch(this, function(versionId, documentId, currentTableRow, row) {
					this.setRowAsSelected(currentTableRow);
					this.loadVersionList(versionId, documentId);
					
			}, versionSeriesId, documentId, tr, currentRow);
		} else if (this.canViewVersions && versionSeriesId == undefined) {
			// (Custom) Query did not return version series Id even though user wants to use it. 
			var versionsIcon = createAndAppendChildElement('img', tdActions, "");
			versionsIcon.src=this.teamworksContextRoot +"/images/ECM/ecm_documentversions_disabled_image.png" 
			versionsIcon.height=16; 
			versionsIcon.width=16;
			versionsIcon.title=documentListView_noVersionIdError; 
			createAndAppendChildElementWithText('span', tdActions, "", " ");
		}
		
		currentRow++;
		
	}
	
	// No need for pagination buttons if showAllContent is true
	if (this.showAllContent) return;
	
	
	// Navigation Bar
	trNav = createAndAppendChildElement('tr', table, "");
	tdNav = createAndAppendChildElement('td', trNav, "classNavBar");
	tdNav.colSpan = totalColumns;

	// Next / Previous
	var linkPrev = createAndAppendChildElement('a', tdNav, "");
	linkPrev.onclick = dojo.hitch(this, function(link) { 
			if(isBrowserIE()){
				link.onclick=function(){return false;}; // Disable link after clicking
			}else{
				link.onclick=void(0); // Disable link after clicking
			}
			this.skipCount-=this.maxItems;
			this.pageNumber--;
			this.loadDocumentList();
        }, linkPrev);	
	this.createHoverLink(linkPrev, this.navPrevImg, this.navPrevImgHover, documentListView_pageBack, false);
	
	
	if (this.skipCount==0) linkPrev.className += "disabled"; // Better to create then hide (rather than not create at all) since the other button will not become fully centered
	
	createAndAppendChildElementWithHtmlContent('span', tdNav, "", "&nbsp;&nbsp;&nbsp; " + documentListView_page + " : ");
	createAndAppendChildElementWithText('span', tdNav, "selectedPage", this.pageNumber);	
	createAndAppendChildElementWithHtmlContent ('span', tdNav, "", "&nbsp;&nbsp;&nbsp;");
	
	var linkNext = createAndAppendChildElement('a', tdNav, "");
	/* Need to do dojo.hitch here to pass in context (DocumentListControl). In the commented-out code below, 'this' is actually the window, and it will fail
	linkNext.onclick = function() {
		this.skipCount+=this.maxItems;
		this.loadDocumentList();
	}*/
	linkNext.onclick = dojo.hitch(this, function(link) {
			if(isBrowserIE()){
				link.onclick=function(){return false;}; // Disable link after clicking
			}else{
				link.onclick=void(0); // Disable link after clicking
			}
			this.skipCount+=this.maxItems;
			this.pageNumber++;
			this.loadDocumentList();
        }, linkNext);
	this.createHoverLink(linkNext, this.navNextImg, this.navNextImgHover, documentListView_pageNext, true);
	
	if (hasMoreItems=="false") linkNext.className += "disabled";
	
}



/* Creates a link with hover images, with optional text (set linkText to "" if optional) */
DocumentListControl.prototype.createHoverLink = function( link, targetImg, targetImgHover, linkText, isTextBeforeImg, imgTitle, imgHeight, imgWidth) {

	linkImg = new Image();
	linkImg.src = targetImg.src;
	
	if (imgHeight != undefined && imgHeight > 0)  
		linkImg.height=imgHeight;
	if (imgWidth != undefined && imgWidth > 0)  
		linkImg.width=imgWidth;
	if (imgTitle != undefined)
		linkImg.title=imgTitle;
	
	if (isTextBeforeImg == true) 
		link.appendChild(document.createTextNode(linkText + " "));
	link.appendChild(linkImg);
	if (isTextBeforeImg == false) 
		link.appendChild(document.createTextNode(" " + linkText));

	link.onmouseover = dojo.hitch(this, swapImages, linkImg, targetImgHover);
	link.onmouseout =  dojo.hitch(this, swapImages, linkImg, targetImg);
	
}

function swapImages(targetImg, sourceImg) {
	targetImg.src=sourceImg.src;
} 

/**
 * Initializes the create button and the create document dialog.
*/
DocumentListControl.prototype.initDocumentDialog = function() {
	// add button
	if (this.allowCreate) { // && this.context.options.enableUpload);
		if(!this.addDocumentButton) {		
			this.addDocumentButton = document.createElement("input");
			this.addDocumentButton.type = "button";
			this.addDocumentButton.className = "blue";
			this.addDocumentButton.value = documentListView_uploadDoc_button;
			this.addDocumentButton.onclick = dojo.hitch(this, function() {
				this.openCreateDocumentDialog();
			});
			this.documentListFieldSet.appendChild(this.addDocumentButton);
		} else {
			setVisible(this.addDocumentButton, true);
		}
	} else {
		if(this.addDocumentButton) {		
			setVisible(this.addDocumentButton, false);
		}
	}
	
	// refresh button
	if(!this.refreshButton) {
		this.refreshButton = document.createElement("input");
		this.refreshButton.type = "button";
		this.refreshButton.className = "blue";
		this.refreshButton.value = documentListView_button_refresh;
		this.refreshButton.onclick = dojo.hitch(this, function() {
			this.loadDocumentList();
		});
		this.documentListFieldSet.appendChild(this.refreshButton);
	}
	
}

DocumentListControl.prototype.getSnapshotId = function() {
	var searchURL = dojo.queryToObject(this.searchUrl.substring(this.searchUrl.indexOf("?") + 1));
	return searchURL.snapshotId;
}

/** Gets the resource bundle */
DocumentListControl.prototype.getResourceBundle = function() {
	try{
	dojo.xhrGet( {
	    url: jsonResURL,
	    handleAs: "json",
	    load: function(responseObject, ioArgs) {
	    resourceBundle = responseObject;
	    	documentListView_URLHeader = responseObject.documentListView_URLHeader;
			documentListView_button_addDoc = responseObject.documentListView_button_addDoc;
			documentAttachment_uploadDoc = responseObject.documentAttachment_uploadDoc;
			documentListView_label_file = responseObject.documentListView_label_file;
			documentListView_label_url = responseObject.documentListView_label_url;
			documentListView_button_ok = responseObject.documentListView_button_ok;
			documentListView_bpmDocTypeLabel_file = responseObject.documentListView_bpmDocTypeLabel_file;
			documentListView_bpmDocTypeLabel_url = responseObject.documentListView_bpmDocTypeLabel_url;
			documentListView_button_cancel = responseObject.documentListView_button_cancel;
			documentListView_requiredFieldsMissing = responseObject.documentListView_requiredFieldsMissing;		
			documentListView_uploadDoc = responseObject.documentListView_uploadDoc;
			documentListView_uploadDoc_button = responseObject.documentListView_uploadDoc_button;
			documentListView_documentContentHeader = responseObject.documentListView_documentContentHeader;
			documentListView_bpmDocumentType = responseObject.documentListView_bpmDocumentType;
			documentListView_urlLinkHeader = responseObject.documentListView_urlLinkHeader;
			documentListView_documentPropertiesHeader = responseObject.documentListView_documentPropertiesHeader;
			documentListView_documentTypeHeader = responseObject.documentListView_documentTypeHeader;
			documentListView_documentCreationFailure = responseObject.documentListView_documentCreationFailure;
			documentListView_documentCreationSuccess = responseObject.documentListView_documentCreationSuccess;
			documentListView_documentTypesError = responseObject.documentListView_documentTypesError;
			documentListView_getDocumentAJAXSrvcError = responseObject.documentListView_getDocumentAJAXSrvcError;
			documentListView_getTypeDescendantsAJAXSrvcError = responseObject.documentListView_getTypeDescendantsAJAXSrvcError;
			documentListView_invalidValues = responseObject.documentListView_invalidValues;
			documentListView_invalidInteger = responseObject.documentListView_invalidInteger;
			documentListView_invalidDecimal = responseObject.documentListView_invalidDecimal;
			documentListView_invalidDateTime = responseObject.documentListView_invalidDateTime;
			documentListView_invalidValue = responseObject.documentListView_invalidValue;
			documentListView_getTypeDefinitionAJAXSrvcError = responseObject.documentListView_getTypeDefinitionAJAXSrvcError;
			documentListView_noNameNoContent = responseObject.documentListView_noNameNoContent;
			documentListView_noContentWithName = responseObject.documentListView_noContentWithName;
			documentListView_noContentWithProperties = responseObject.documentListView_noContentWithProperties;
			documentListView_button_refresh = responseObject.documentListView_button_refresh;
			documentListView_title = responseObject.documentListView_title;
			documentListView_documentVersionsError = responseObject.documentListView_documentVersionsError;
			documentListView_documentContentView = responseObject.documentListView_documentContentView;
			documentListView_documentSearchError = responseObject.documentListView_documentSearchError;
			documentListView_documentSearchError_missingProperties = responseObject.documentListView_documentSearchError_missingProperties;
			documentListView_noDocumentsFound = responseObject.documentListView_noDocumentsFound;
			documentListView_revisionTitle = responseObject.documentListView_revisionTitle;
			documentListView_fileNameTitle = responseObject.documentListView_fileNameTitle;
			documentListView_revisionDateTitle = responseObject.documentListView_revisionDateTitle;
			documentListView_lastModifiedByTitle = responseObject.documentListView_lastModifiedByTitle;
			documentListView_createdByTitle = responseObject.documentListView_createdByTitle;
			documentListView_actionsTitle = responseObject.documentListView_actionsTitle;
			documentListView_pageBack = responseObject.documentListView_pageBack;
			documentListView_pageNext = responseObject.documentListView_pageNext;
			documentListView_page = responseObject.documentListView_page;
			documentListView_versionsTitle = responseObject.documentListView_versionsTitle;
			documentListView_closeButton = responseObject.documentListView_closeButton
			documentListView_revisionsTitle = responseObject.documentListView_revisionsTitle;
			documentListView_documentUpdateSuccess = responseObject.documentListView_documentUpdateSuccess;
			documentListView_documentUpdateFailure = responseObject.documentListView_documentUpdateFailure;
			documentListView_documentUpdateWarningUpdateContent = responseObject.documentListView_documentUpdateWarningUpdateContent;
			documentListView_valueRequired = responseObject.documentListView_valueRequired;
			documentListView_viewDoc = responseObject.documentListView_viewDoc;
			documentListView_updateDoc = responseObject.documentListView_updateDoc;
			documentListView_updateDoc_link = responseObject.documentListView_updateDoc_link;
			documentListView_noIdError = responseObject.documentListView_noIdError;
			documentListView_noVersionIdError = responseObject.documentListView_noVersionIdError;
			documentListView_loading = responseObject.documentListView_loading;
	    },
	    sync: true
	});
	}catch(err){
		var a = err;
		//call will be failed if no security context, 
		//if do not catch, the failure will block the preview at the AE
		//do nothing at here, the validation messages will be default(en) at this case
	}

}

/**
 *	Creates the form for the create document scenario
*/
DocumentListControl.prototype.openCreateDocumentDialog = function() {
	this.createDocument = true;
	this.dialog = this.createDocumentDialog(true);
	
	// add hidden attributes
	this.documentForm.targetUrl = this.portalContextRoot+"/jsp/ecmDocument?operation=ajax_createDocument";
	
	createHiddenInputElement(this.documentForm, 'snapshotId', this.getSnapshotId());
	createHiddenInputElement(this.documentForm, 'ecmServerConfigurationName', this.ecmServerConfigurationName);
	createHiddenInputElement(this.documentForm, 'folderPath', this.parentFolderPath);
	//createHiddenInputElement(this.documentForm, 'versioningState', 'major');
	
	//When using BPM Documents we need to supply any upload properties to be included in the document upload
	//as well as the status of the associateWithProcessInstance and hideInPortal properties
	if(this.useBPMDocuments == documentListView_useBPM) {
		for(var i = 0; i < this.uploadPropertiesData.length; i++) {
			createHiddenInputElement(this.documentForm, BPMDocProp_properties + (i == 0 ? "" : "$" + [i]), this.uploadPropertiesData[i]);
		}
		
		createHiddenInputElement(this.documentForm, BPMDocProp_procInstId, this.processInstanceId);
		createHiddenInputElement(this.documentForm, BPMDocProp_hideInPortal, this.hideInPortal);
		createHiddenInputElement(this.documentForm, BPMDocProp_userId, this.userId);
	}
	
	this.dialog.setAttribute("title", documentListView_uploadDoc);
	this.dialog.show();
	this.dialog.setAttribute("style", "position: absolute; top:10%;");
}

/**
 *	Creates the form for the update document scenario
*/
DocumentListControl.prototype.openUpdateDocumentDialog = function(documentId) {
	this.createDocument = false;
	this.dialog = this.createDocumentDialog(false);
	
	// add hidden attributes
    this.documentForm.targetUrl = this.portalContextRoot+"/jsp/ecmDocument?operation=ajax_updateDocument";

	createHiddenInputElement(this.documentForm, 'snapshotId', this.getSnapshotId());
	createHiddenInputElement(this.documentForm, 'ecmServerConfigurationName', this.ecmServerConfigurationName);
	createHiddenInputElement(this.documentForm, 'documentId', documentId);
	//createHiddenInputElement(this.documentForm, 'versioningState', 'major');
	createHiddenInputElement(this.documentForm, 'ecmServerType', this.useBPMDocuments);
	
	this.dialog.setAttribute("title", documentListView_updateDoc);
	this.dialog.show();
	this.dialog.setAttribute("style", "position: absolute; top:10%;");
	inputParameters='<input name=\"elementValue\"><variable name=\"documentId\">'+documentId+'</variable><variable name=\"serverName\">'+this.ecmServerConfigurationName+'</variable></input>'; 
	
	if (!this.getDocumentUrl) {
		alert(documentListView_getDocumentAJAXSrvcError);
		return;
	}
	var getDocumentURL = this.getDocumentUrl + '&input=' + inputParameters;
	
	dojo.xhrGet({
        url: getDocumentURL,
        handleAs: "xml",
        load: dojo.hitch(this, function(xmlDoc) {
			try {
				if(!xmlDoc)
					return;
				var objectTypeIds = xmlDoc.getElementsByTagName("objectTypeId");
				createHiddenInputElement(this.documentForm, 'objectTypeId', objectTypeIds[0].childNodes[0].data);
				this.populateDocumentPropertiesForm(objectTypeIds[0].childNodes[0].data, xmlDoc);
			} catch (e) {
				alert(e);
			}
        }),
        error: dojo.hitch(this, function(o) {
        	alert(documentListView_documentTypesError);
        })
    });	
}

DocumentListControl.prototype.createDocumentDialog = function(showDocumentTypeSelector) {
	var obj = this;
	
	var dialog = new dijit.Dialog({
		title: "Upload Document"
    });
	
	this.invalidFormError = createChildElement("text", undefined);
	this.invalidFormError.innerHTML = documentListView_requiredFieldsMissing;
	this.invalidFormError.setAttribute('style', 'color: #FF0000');
	this.invalidFormError.id = "invalidFormError";
	setVisible(this.invalidFormError, false);
	
	this.invalidValueError = createChildElement("text", undefined);
	this.invalidValueError.innerHTML = documentListView_invalidValues;
	this.invalidValueError.setAttribute('style', 'color: #FF0000');
	this.invalidValueError.id = "invalidValueError";
	setVisible(this.invalidValueError, false);
	
	if (showDocumentTypeSelector) {
		this.select = document.createElement("select");
		this.select.name = "objectTypeId";
		this.select.onchange = dojo.hitch(this, function() {
			this.populateDocumentPropertiesForm(this.select.options[this.select.selectedIndex].value);
		});
		
		this.select.style.width = "100%";
		this.select.setAttribute("size", 1);
		this.documentTypeFieldSet = new FieldSet(documentListView_documentTypeHeader);
		this.documentTypeFieldSet.className = "twDocAttachmentUploadBorder";
		this.documentTypeFieldSet.init();	
//		if (!this.context.documentType)
//			this.context.documentType = "cmis:document";
		this.setBaseDocumentType();
		this.documentTypeFieldSet.addElement("select", this.select);
	} 
	
	this.documentPropertiesFieldSet = new FieldSet(documentListView_documentPropertiesHeader);
	this.documentPropertiesFieldSet.className = "twDocAttachmentUploadBorder";
	this.documentPropertiesFieldSet.init();
	
	this.documentContentFieldSet = new FieldSet(documentListView_documentContentHeader);
	this.documentContentFieldSet.className = "twDocAttachmentUploadBorder";
	this.documentContentFieldSet.init();
	this.documentContentFieldSet.addRowWithoutSubDiv(documentListView_label_file , createInputElement('fileContent', 'file'), true, "fileContent", 'false');
	
	this.documentUrlLinkFieldSet = new FieldSet(documentListView_urlLinkHeader);
	this.documentUrlLinkFieldSet.className = "twDocAttachmentUploadBorder";
	this.documentUrlLinkFieldSet.init();
	this.documentUrlLinkFieldSet.root.style.display = "none";
	this.documentUrlLinkFieldSet.addRow(documentListView_label_url, createInputElement(BPMDocProp_url, 'string'), true, BPMDocProp_url, 'false', BPMDocProp_url, null);
	createTextBoxWidget(BPMDocProp_url, BPMDocProp_url, false, input, 'fileContent');
	dijit.byId(BPMDocProp_url).set('style', 'width:505px');
	
	var ok = createButton1(documentListView_button_ok, function() {
 		obj.onsubmit();
 	});
	ok.className = "blue";

	var cancel = createButton1(documentListView_button_cancel, function(){ 		
 		obj.onclose();
 	});
	cancel.className = "blue";
		
	// place it into form	
	this.documentForm = createChildElement("form", undefined);
	this.documentForm.setAttribute('method', 'post');
	this.documentForm.setAttribute('enctype', 'multipart/form-data');

	this.documentForm.appendChild(this.invalidFormError);
	this.documentForm.appendChild(this.invalidValueError);
	if (showDocumentTypeSelector)
		this.documentForm.appendChild(this.documentTypeFieldSet.root);
	
	this.documentForm.appendChild(this.documentPropertiesFieldSet.root);
	this.documentForm.appendChild(this.documentContentFieldSet.root);
	this.documentForm.appendChild(this.documentUrlLinkFieldSet.root);
	this.documentForm.appendChild(ok);
	this.documentForm.appendChild(cancel);
	
	dialog.setAttribute("content", this.documentForm);
	return dialog;
}

/**
*	Adds the document type received form the search result to the list of document types
*/
DocumentListControl.prototype.setBaseDocumentType = function() {
	inputParameters='<input name=\"elementValue\"><variable name=\"objectTypeId\">'+this.selectedObjectTypeId+'</variable><variable name=\"serverName\">'+this.ecmServerConfigurationName+'</variable></input>'; 
	
	if (!this.getTypeDefUrl)
		alert(documentListView_getTypeDefinitionAJAXSrvcError);
		
	var getTypeDefURL = this.getTypeDefUrl + '&input=' + inputParameters;
	
	dojo.xhrGet({
        url: getTypeDefURL,
        handleAs: "xml",
        load: dojo.hitch(this, function(xmlDoc) {
			try {
				if(!xmlDoc) {
					this.selectedObjectTypeId = 'cmis:document';
					return;
				}
				path="//variable/displayName";
				// code for IE
				if (window.ActiveXObject)
				{
					var nodes;
					if(dojo.isIE < 10) {
						nodes=xmlDoc.selectNodes(path);
					} else {
						//IE 10 returns an MSHTML document and does not provide XPath Support
						//So we'll parse it the old-fashioned way.
						nodes=[];
						var variable=xmlDoc.getElementsByTagName("variable");
						for(variableIndex=0;variableIndex<variable.length;variableIndex++) {
							var element=variable[variableIndex].childNodes;
							for(elementIndex=0;elementIndex<element.length;elementIndex++) {
								if(element[elementIndex].nodeName == "displayName") {
									nodes.push(element[elementIndex]);
								}
							}
						}
					}
					
					for (i=0;i<nodes.length;i++)
					{
						var option;
						/* we are going to add two options */
						/* create options elements */
						option = document.createElement("option");
						option.setAttribute("value", this.selectedObjectTypeId);
						option.innerHTML = nodes[i].childNodes[0].nodeValue;
						option.selected = true;
						this.select.appendChild(option);
	
					}
				}
				// code for Mozilla, Firefox, Opera, etc.
				else if (document.implementation && document.implementation.createDocument)
				{
					var nodes=xmlDoc.evaluate(path, xmlDoc, null, XPathResult.ANY_TYPE, null);
					var result=nodes.iterateNext();
					
					while(result)
					{
						var option;
						/* we are going to add two options */
						/* create options elements */
						option = document.createElement("option");
						option.setAttribute("value", this.selectedObjectTypeId);
						option.innerHTML = result.childNodes[0].nodeValue;
						option.selected = true;
						this.select.appendChild(option);
						result=nodes.iterateNext();
					}
					
				}
			} catch (e) {
				alert(e);
			} finally {
				if(xmlDoc) {
					this.loadDocumentTypes();
				}
			}
        }),
        error: dojo.hitch(this, function(o) {
        	alert(documentListView_documentTypesError);
        })
    });
	
}

/**
*	Sets the top level document types and then calls the setChildDocumentTypes
*/
DocumentListControl.prototype.setTopLevelDocumentTypes = function(content) {	
	var variable = content.getElementsByTagName("variable");
	this.setChildDocumentTypes(variable[0]);
	
}

/**
*	Recursively goes to the child of each item and adds spacing for tree like structure.
*/
DocumentListControl.prototype.setChildDocumentTypes = function(result) {
		var itemsArray = getChildren(result, 'item');
		itemsArray.sort(function(a,b) {
		var aCat = a.getElementsByTagName("displayName")[0].childNodes[0].nodeValue;
		var bCat = b.getElementsByTagName("displayName")[0].childNodes[0].nodeValue;
		if (aCat > bCat) return 1;
		if (aCat < bCat) return -1;
		return 0;
		});
		
		amountOfSpacing = amountOfSpacing + 1;
		
		for(var i = 0, count = itemsArray.length; i < count; i++) {
			if(this.select.size < 5) {
					this.select.setAttribute("size", this.select.size + 1);
			}
			numberOfObjects = numberOfObjects + 1;
			var spacing = "";
			for(j = 0; j < amountOfSpacing; j++) {
				spacing = spacing + '\u00a0\u00a0\u00a0\u00a0';
			}
			var children = itemsArray[i].getElementsByTagName('children')[0];
			var displayName = itemsArray[i].getElementsByTagName('displayName')[0];
			var objectTypeId = itemsArray[i].getElementsByTagName('objectTypeId')[0];
			var displayNameText = spacing + displayName.childNodes[0].nodeValue;
			var objectTypeIdText = objectTypeId.childNodes[0].nodeValue;
			
			option = document.createElement("option");
			option.setAttribute("value", objectTypeId.childNodes[0].nodeValue);
			option.innerHTML = displayNameText;
			this.select.appendChild(option);
						
			if(children.childElementCount != 0) {
				this.setChildDocumentTypes(children);
			}
		}
		amountOfSpacing = amountOfSpacing - 1;
}

/**
* Loads list of documents types
*/
DocumentListControl.prototype.loadDocumentTypes = function() {

	inputParameters='<input name=\"elementValue\"><variable name=\"objectTypeId\">'+this.selectedObjectTypeId+'</variable><variable name=\"serverName\">'+this.ecmServerConfigurationName+'</variable></input>'; 
	
	if (!this.getTypesUrl) {
		alert(documentListView_getTypeDescendantsAJAXSrvcError);
		return;
	}
	var getTypesURL = this.getTypesUrl + '&input=' + inputParameters;
	
	 dojo.xhrGet({
        url: getTypesURL,
        handleAs: "xml",
        load: dojo.hitch(this, function(xmlDoc) {
			try {
				if(!xmlDoc)
					return;
				this.setTopLevelDocumentTypes(xmlDoc);
			} catch (e) {
				alert(e);
			} finally {
				this.populateDocumentPropertiesForm(this.selectedObjectTypeId);
			}
        }),
        error: dojo.hitch(this, function(o) {
        	alert(documentListView_documentTypesError);
        })
    });
	
}

/**
* Builds a form based on the properties of the selected document type
* rootElement: The element the form will be created under
* context: context of the view invoking this function
* content: selected document type
*/
DocumentListControl.prototype.populateDocumentPropertiesForm = function(documentType, ecmDoc) {
	setVisible(this.invalidFormError, false);
	this.objectTypeIdToSubmit = documentType;
	this.ecmDocToSubmit = ecmDoc;
	inputParameters='<input name=\"elementValue\"><variable name=\"objectTypeId\">'+documentType+'</variable><variable name=\"serverName\">'+this.ecmServerConfigurationName+'</variable></input>';
	
	if (!this.getTypeDefUrl) {
		alert(documentListView_getTypeDefinitionAJAXSrvcError);
		return;
	}
	var getTypeDefURL = this.getTypeDefUrl + '&input=' + inputParameters;
	
	 dojo.xhrGet({
        url: getTypeDefURL,
        handleAs: "xml",
        load: dojo.hitch(this, function(xmlDoc) {
			try {
				if(!xmlDoc)
					return;
					
//				if (this.documentPropertiesFieldSet.tbody) 
//					this.documentPropertiesFieldSet.tbody.innerHTML = "";
				this.documentPropertiesFieldSet.saveState();
				this.documentPropertiesFieldSet.clear1();
				
				var excludedProperties = [];
				
				var propertyTypeDefintiions = xmlDoc.getElementsByTagName("propertyTypeDefinitions");
				if (propertyTypeDefintiions.length > 0) {
					var propertyTypeDefintiionItems = getChildren(propertyTypeDefintiions[0], 'item');
					// Assume only 1 propertyTypeDefinitions tag in result. 
					// Note that the list will not be null even if no items are present.
				
					for (i=0; i<propertyTypeDefintiionItems.length; i++) {	
						
						// Mandatory Properties
						var objectTypeId = propertyTypeDefintiionItems[i].getElementsByTagName('objectTypeId')[0].childNodes[0].data;
						var required = propertyTypeDefintiionItems[i].getElementsByTagName('required')[0].childNodes[0].data;
						var cardinality = propertyTypeDefintiionItems[i].getElementsByTagName('cardinality')[0].childNodes[0].data;
						var propertyType = propertyTypeDefintiionItems[i].getElementsByTagName('propertyType')[0].childNodes[0].data;
						var updatability = propertyTypeDefintiionItems[i].getElementsByTagName('updatability')[0].childNodes[0].data;
						var choices = propertyTypeDefintiionItems[i].getElementsByTagName('choices');
						
						// PMR 109871 (02815,999,808): In some rare cases, it seems that displayName returned can be null. 
						// Either <displayName></displayName> or <displayName/>In
						// those cases, we'll use the objectTypeId;s value
						var displayName = objectTypeId;
						if((propertyTypeDefintiionItems[i].getElementsByTagName('displayName').length > 0) && 
						(propertyTypeDefintiionItems[i].getElementsByTagName('displayName')[0].childNodes.length>0) ) {
							displayName = propertyTypeDefintiionItems[i].getElementsByTagName('displayName')[0].childNodes[0].data;
						}
						
						//When using BPM Documents we need to display a particular UI
						if(this.useBPMDocuments == documentListView_useBPM) {
							if (indexOf(excludeBPMDocumentProperties, objectTypeId) >= 0) {
								//dont push URL property on excluded list since need it to populate when updating
								if(objectTypeId != BPMDocProp_url && objectTypeId != BPMDocProp_fileType) {
									excludedProperties.push(objectTypeId);
								}
								continue;
							}
						}
						
						if (indexOf(systemPropertyTypeIds, objectTypeId) >= 0) {
							excludedProperties.push(objectTypeId);
							continue;
						}
						
						if(updatability == 'readonly') { // can't update read-only
							excludedProperties.push(objectTypeId);
							continue;
						}
							
						if(this.ecmDocToSubmit && updatability == 'oncreate') { // can't update on document update
							excludedProperties.push(objectTypeId);
							continue;
						}
							
						if(!this.ecmDocToSubmit && updatability == 'whencheckedout') { // can't update on document creation
							excludedProperties.push(objectTypeId);
							continue;
						}

						if(objectTypeId == 'cmis:name') {
							required = 'true';
						}
						
						var add = null;
						if (cardinality == 'multi') {
							add = createButton1('Add', function() {
								
								if (this.currentNumber == 0) {
									tr = this.documentPropertiesFieldSet.getRow1(this.objectTypeId);
								} else {
									tr = this.documentPropertiesFieldSet.getRow1(this.objectTypeId + "$" + this.currentNumber.toString());
								}
								this.currentNumber = this.currentNumber + 1;
								var newObjectTypeId = this.objectTypeId + "$" + this.currentNumber.toString();
								
								var input = createInputElement(newObjectTypeId, this.propertyType);
								
								if (this.choices.length > 0) {
									var choiceItems = getChildren(this.choices[0], 'item');
									if(choiceItems.length > 0) {
										var values = [];
										
										input.type = 'select-one';
										input.name = newObjectTypeId;
										dt = dijit.byId(newObjectTypeId);
										if (dt)
											dt.destroy();
										for (k=0; k<choiceItems.length; k++) {
											values.push({name:choiceItems[k].childNodes[0].nodeValue});
										}
										var dataItems = {
											identifier: 'name',
											label: 'name',
											items: values
										};
										var store = new dojo.data.ItemFileReadStore({data:dataItems});
										input.values = values;
										this.documentPropertiesFieldSet.insertAfterRow(tr, "", input, true, newObjectTypeId, this.required, this.propertyType);
										createFilteringSelectWidget(newObjectTypeId, newObjectTypeId, this.required == 'true', store, input);
									}
								}
								
								if(input.type != "select-one") {
									this.documentPropertiesFieldSet.insertAfterRow(tr, "", input, true, newObjectTypeId, this.required, this.propertyType);
									if (this.propertyType == 'datetime') {
										createDateTimeWidget(newObjectTypeId, newObjectTypeId, this.required == 'true', input);
									} else if (this.propertyType == 'boolean') {
										createCheckBoxWidget(newObjectTypeId, newObjectTypeId, input);
									} else {
										if(this.propertyType != 'hidden' && this.propertyType != 'file') {
											createTextBoxWidget(newObjectTypeId, newObjectTypeId, required == 'true', input, this.propertyType);
										}
									}
								}
								
							});
							
							add.required = required;
							add.objectTypeId = objectTypeId;
							add.propertyType = propertyType;
							add.choices = choices;
							add.documentPropertiesFieldSet = this.documentPropertiesFieldSet;
							add.currentNumber = 0;
							add.className = 'blue';
							add.id = 'addButton';
						}
						
						var input = createInputElement(objectTypeId, propertyType);
						
						if (choices.length > 0) {
							var choiceItems = getChildren(choices[0], 'item');
							if(choiceItems.length > 0) {
								var values = [];
								
								input.type = 'select-one';
								input.name = objectTypeId;
								dt = dijit.byId(objectTypeId);
								if (dt)
									dt.destroy();
								for (j=0; j<choiceItems.length; j++) {
									values.push({name:choiceItems[j].childNodes[0].nodeValue});
								}
								var dataItems = {
									identifier: 'name',
									label: 'name',
									items: values
								};
								input.values = values;
								var store = new dojo.data.ItemFileReadStore({data:dataItems});
								this.documentPropertiesFieldSet.addRow(displayName, input, true, objectTypeId, required, propertyType, add);
								createFilteringSelectWidget(objectTypeId, objectTypeId, required == 'true', store, input);
							}
						}
						
						if(input.type != "select-one") {
							this.documentPropertiesFieldSet.addRow(displayName, input, true, objectTypeId, required, propertyType, add);
							if (propertyType == 'datetime') {
								createDateTimeWidget(objectTypeId, objectTypeId, required == 'true', input);
							} else if (propertyType == 'boolean') {
								createCheckBoxWidget(objectTypeId, objectTypeId, input);
							} else {
								if(propertyType != 'hidden' && propertyType != 'file') {
									createTextBoxWidget(objectTypeId, objectTypeId, required == 'true', input, propertyType);
								}
							}
						}
					}
					
					//When using BPM Documents we need to display a particular UI
					if(this.useBPMDocuments == documentListView_useBPM) {
						var objectTypeId = BPMDocProp_fileType;
						var propertyType = 'string';
						var input = createInputElement(objectTypeId, propertyType);
						var values = [{'name' : documentListView_bpmDocTypeLabel_file, 'id' : BPMDoc_fileType_file}, 
						              {'name' : documentListView_bpmDocTypeLabel_url, 'id' : BPMDoc_fileType_url}];
						
						input.type = 'select-one';
						input.name = objectTypeId;
						dt = dijit.byId(objectTypeId);
						if (dt)
							dt.destroy();
						var dataItems = {
								identifier: 'id',
								label: 'name',
								items: values
						};
						input.values = values;
						var store = new dojo.data.ItemFileReadStore({data:dataItems});
						this.documentPropertiesFieldSet.addRow(documentListView_bpmDocumentType, input, true, objectTypeId, 'false', propertyType, null);
						this.bpmDocTypeWidget = createSelectWidget(objectTypeId, objectTypeId, false, store, input);
						this.bpmDocTypeWidget.set('value', BPMDoc_fileType_file);
						this.bpmDocTypeWidget.domNode.style.margin = "0";
						//this.bpmDocTypeWidget.domNode.style.width = "100px";
						//this.bpmDocTypeWidget.set('autoWidth', 'false');
						this.bpmDocTypeWidget.onChange = dojo.hitch(this, function() {
							if(this.bpmDocTypeWidget.value == BPMDoc_fileType_file) {
								this.documentContentFieldSet.root.style.display = "block";
								this.documentUrlLinkFieldSet.root.style.display = "none";
							} else {
								this.documentContentFieldSet.root.style.display = "none";
								this.documentUrlLinkFieldSet.root.style.display = "block";
							}
							
						});
						
						//Set the default Document Title if the config option has been set to include it 
						if(this.defaultUploadName != "") {
							initializeFieldValue(this.documentPropertiesFieldSet, 'cmis:name', [{value:this.defaultUploadName, type:'text'}]);
							
							var cmisName = dijit.byId('cmis:name');
							if(cmisName) {
								if(this.userEditable == false) {
									cmisName.set('readOnly', 'readOnly');
								}
							}
						}
					}
				}
				
				if (this.ecmDocToSubmit) {
					var variables = this.ecmDocToSubmit.getElementsByTagName('variable');
					if (variables.length > 0 ) {
						var names = getChildren(variables[0], 'name');
						if (names.length > 0) {							
							if (indexOf(excludedProperties, 'cmis:name') == -1) {
								initializeFieldValue(this.documentPropertiesFieldSet, 'cmis:name', convertValues([names[0]]));
							}
						} 
					}
					
					var properties = this.ecmDocToSubmit.getElementsByTagName('properties');
					if (properties.length > 0) {
						var propertyItems = getChildren(properties[0], 'item'); 
						// Assume only 1 properties tag in result. 
						// Note that the list will not be null even if no items are present.
						if (propertyItems.length > 0) {
							var i=0;
							for (i=0; i<propertyItems.length; i++) {								
								var objectTypeIds = propertyItems[i].getElementsByTagName('objectTypeId');																	
								var values = getChildren(propertyItems[i], 'value');
								if (objectTypeIds.length > 0 && values.length > 0) {
									// Assume only 1 objectTypeId tag in result
									// Assume only 1 value tag in result
									if (indexOf(excludedProperties, objectTypeIds[0].childNodes[0].data) == -1) {
										var fieldToInit = this.documentPropertiesFieldSet;
										if(this.useBPMDocuments == documentListView_useBPM) {
											if(objectTypeIds[0].childNodes[0].data == BPMDocProp_url) {
												fieldToInit = this.documentUrlLinkFieldSet;
											}
										}
										initializeFieldValue(fieldToInit, objectTypeIds[0].childNodes[0].data, convertValues(values));
									}
								}
							}
							if(this.useBPMDocuments == documentListView_useBPM) {
								if(this.bpmDocTypeWidget.value == BPMDoc_fileType_file) {
									var urlField = dijit.byId(BPMDocProp_url);
									urlField.set('value', "");
								}
							}
						}						
					}
				} else {
					this.documentPropertiesFieldSet.popState();
				}				
			} catch (e) {
				alert(e);
			}
        }),
        error: dojo.hitch(this, function(o) {
        	alert(documentListView_documentTypesError);
        })
    });
}

/**
*	Clicking the Cancel button
*/
DocumentListControl.prototype.onclose = function() {
	this.dialog.hide();	
	if(!!this.documentPropertiesFieldSet.tbody){
		//this.documentPropertiesFieldSet.tbody.innerHTML = "";
		while(this.documentPropertiesFieldSet.tbody.hasChildNodes())
		{
			this.documentPropertiesFieldSet.tbody.removeChild(this.documentPropertiesFieldSet.tbody.firstChild);
		}
	}

	if(!!this.documentForm.innerHTML){
		//this.documentForm.innerHTML = "";
		while(this.documentForm.hasChildNodes())
		{
			this.documentForm.removeChild(this.documentForm.firstChild);
		}
	}

}; 
		
/**
*	Clicking the OK button
*/
DocumentListControl.prototype.onsubmit = function() {

	if (!this.validate())
		return;
	
	//When using BPM Documents we need to remove the BPMDocType field since it is only used for UI
	if(this.useBPMDocuments == documentListView_useBPM) {
		var docTypeSelector = dijit.byId(BPMDocProp_fileType);
		var docType = docTypeSelector.get('value');
		
		//If the docTypeSelector is not set to URL then do not submit a value in this field
		if(docType != BPMDoc_fileType_url) {
			var fileField = dojo.byId('fileContent');
			var fileName = fileField.children[1].children[0].value;
			var lastSlash = Math.max(fileName.lastIndexOf("/"), fileName.lastIndexOf("\\"));
			if(lastSlash > -1) {
				fileName = fileName.substr(lastSlash + 1);
			}
			
			var urlField = dijit.byId(BPMDocProp_url);
			urlField.set('value', fileName);
		}
		//If the docTypeSelector is not set to File then do not submit a value in this field
		if(docType != BPMDoc_fileType_file) {
			var fileField = dojo.byId('fileContent');
			fileField.children[1].children[0].value = "";
		}
	}
	
	control = this;
	
	this.iframe(this.documentForm.targetUrl,{
			form: this.documentForm,
			handleAs: "xml"}).then(function(data) {
	        	var serviceResponses = data.getElementsByTagName("serviceResponse");
	        	if (serviceResponses != null && serviceResponses.length > 0) {
	        		if(control.createDocument)
						alert(documentListView_documentCreationSuccess);
					else
						alert(documentListView_documentUpdateSuccess);
	        		control.onclose();
	        		control.loadDocumentList();
	        	} else {
					if(control.createDocument)
						alert(documentListView_documentCreationFailure);
					else {
						var errorResponse = data.getElementsByTagName("serviceError");
						if (errorResponse != null && errorResponse.length > 0) {
							alert(documentListView_documentUpdateWarningUpdateContent);
							control.onclose();
							control.loadDocumentList();
						} else {
							alert(documentListView_documentUpdateFailure);
						}
					}
	        	}
	        },function(err) {
	        	if(control.createDocument)
					alert(documentListView_documentCreationFailure);
				else
					alert(documentListView_documentUpdateFailure);
	        });

	// TODO show status message "document being created/updated
};

DocumentListControl.prototype.refresh = function() {
	this.reInitializeConfigOptions();
	if (this.context.binding) 	{
		this.dataBinding = this.context.binding.boundObject;
		this.dataBindingList = this.dataBinding.get(this.context.binding.property); 
		//items[], listSelectedIndex and listSelected
	}
	this.loadDocumentList();
}

DocumentListControl.prototype.validate = function() {
	var valid = this.documentPropertiesFieldSet.validate();
	// If properties validation returns true, get return value for file content section
	//if(valid)
		//valid = this.documentContentFieldSet.validate();
	if(valid) {
		valid = this.documentPropertiesFieldSet.validateValues();
	}
	if(valid) {
		if(this.useBPMDocuments == documentListView_useBPM) {
			var docTypeSelector = dijit.byId(BPMDocProp_fileType);
			//Only validate if the docTypeSelector set to File
			if(docTypeSelector.get('value') == BPMDoc_fileType_file) {
				valid = this.documentContentFieldSet.validateFileContent(this.createDocument);
			}
		} else {
			valid = this.documentContentFieldSet.validateFileContent(this.createDocument);
		}
	}
//	if(valid) {
//		valid = this.documentUrlLinkFieldSet.validateURLContent(this.createDocument);
//	}
	return valid;
}
