/*
Licensed Materials - Property of IBM
5725-C95
Copyright IBM Corporation 2012. All Rights Reserved.
US Government Users Restricted Rights- Use, duplication or disclosure
restricted by GSA ADP Schedule Contract with IBM Corp.
*/

// boundary event utilities

define(["./BPM_CONSTANTS", "./commonHelper", "./logger"], function(BPM_CONSTANTS, commonHelper, logger) {
				
	var boundaryEventHelper = new Object();

	boundaryEventHelper.callbackForBoundaryEvent = function(callbackFun, alwaysInvokeCallback, boundaryEventStatus) {
		var isExecuted = (boundaryEventStatus == BPM_CONSTANTS.BOUNDARY_EVENT_STATUS_EXECUTED);
		if(alwaysInvokeCallback || isExecuted) {
			var response = {status: boundaryEventStatus};
			boundaryEventHelper._invokeCallbackFun(callbackFun, response);
		}
		
		if(!!callbackFun && !alwaysInvokeCallback && !isExecuted) {
			// callback is not invoked although callback function exist. log it here
			logger.log("boundaryEventHelper", "callbackForBoundaryEvent", "supplied callback function is not called for boundary event with status [" + boundaryEventStatus + "]");			
		}
	}
		
	boundaryEventHelper._invokeCallbackFun = function(callbackFun, response) {
		if(!!callbackFun) {
			try {
				callbackFun(response);
			} catch(ex) {
		    	var message = "Coach framework caught exception when calling boundary event's callback function " + callbackFun;
		    	message +=  ", Exception: " + ex;
		    	commonHelper.consoleLog(message, commonHelper.ERROR);
			}
		}
	}
		
	return boundaryEventHelper;
});
