/*
Licensed Materials - Property of IBM
5725-C95
 Copyright IBM Corporation 2012. All Rights Reserved.
US Government Users Restricted Rights- Use, duplication or disclosure
restricted by GSA ADP Schedule Contract with IBM Corp.
*/

// disable back/forward buttons and menu item in context menu

define(["dojo/_base/kernel", "dojo/back"], function(kernel, dojoBack) {
/* Looks we don't need this trick any more.
	// Fix IE issue: iframe_history.html checks if parent window has dojo and if dojo has back. unfortunately "back" is not in "dojo" somehow on IE. We know this dojo already has back module, so correct here if needed 
	if(!!window.dojo && !window.dojo.back) {
		window.dojo.back = dojoBack;
	}
*/
	
	var dojoVersion = kernel.version;
	
	// following content are shared between coach and social portal. Just need to copy them to social portal theme html file. 
	// NOTICE: If you change anything here, please sync the change to social portal.
	
	//*************** BEGIN ****************		
	var nextHashSuffix = "  ";
	
	_ApplicationState = function(stateData, bookmarkValue){
		this.stateData = stateData;
		this.changeUrl = bookmarkValue || false;
		
		this.back = function(){
			if(dojoVersion.major == 1 && dojoVersion.minor < 7) {
				// 1.6 or less
				setTimeout(function() {
					_generateHistory();
				}, 1);
			} else {
				// 1.7 or above
				_generateHistory();
			}
		};
		this.forward = function(){
			// do nothing for now. Since testing shows that forward button and menu item always disabled.
		}
	};
	
	function _generateHistory() {
		var baseHashValue = _getCurrentHash();
		var newHashValue = baseHashValue + nextHashSuffix;
		if(nextHashSuffix == " ") {
			nextHashSuffix = "  ";
		} else {
			nextHashSuffix = " ";
		}
		var appState = new _ApplicationState("Fake history", newHashValue);
		dojoBack.addToHistory(appState);
	}
	
	function _getCurrentHash() {
		var url = window.location;
		var hashValue = !!url.hash ? decodeURI(url.hash).substring(1) : "";
		
		var maxSpaces = "   "; // 3 spaces
		if(hashValue.length >= maxSpaces.length) {
			if(hashValue.substring(hashValue.length - maxSpaces.length) == maxSpaces) {
				// remove last few spaces
				hashValue = hashValue.substring(0, hashValue.length - maxSpaces.length);
			}
		} 
		return hashValue;
	}
	
	function initDisableBack() {
		var appState = new _ApplicationState("Initial state");				
		dojoBack.setInitialState(appState);
		
		// IE doesn't work properly if not to running following logic with a delay
		setTimeout(function() {
			_generateHistory();					
		}, 1000);
	}
	//*************** END ****************
			
	var disableBack = new Object();
	disableBack.init = initDisableBack;
	return disableBack;
});
	